// custrecs.cpp : implementation file
//

#include "stdafx.h"
#include "dbdiplom.h"
#include "variant.h"
#include "custrecs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DCustomRecordset

IMPLEMENT_DYNAMIC(DCustomRecordset, CRecordset)

DCustomRecordset::DCustomRecordset(CDatabase* pdb, COLUMNINFO *pMyColArray, int nNumFields)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(DCustomRecordset)
	m_nFields = nNumFields;
   nNumCols = nNumFields;   
   ColArray = pMyColArray;
	//}}AFX_FIELD_INIT
}

CString DCustomRecordset::GetDefaultConnect()
{
	return "ODBC;DSN=FoxPro 2.0;";
}

CString DCustomRecordset::GetDefaultSQL()
{  
	// Note this is a dummy value.
	return "";
}
               
#define MAX_MEMO_SIZE 2048   // 2K max for memo fields.  (Change to fit your needs.)               
               
void DCustomRecordset::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(DCustomRecordset)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	//}}AFX_FIELD_MAP
	          
	int i;	          
	      
	LPVOID lpColBuffer;  // Address of buffer that will store image of
								// database record.      
	          
   // We need to bind these columns to variables dynamically.
	TRY
	{            
	   for(i = 0; i < nNumCols; i++)
   	{                                    
   		lpColBuffer = ColArray[i].ColData.GetDataPtr();
   		switch(ColArray[i].nSQLDataType)
   		{                                                              
		   	case SQL_BIT:   
   				RFX_Bool(pFX, ColArray[i].szFieldName, *(BOOL far *)lpColBuffer);
   				break;   
                      
				case SQL_TINYINT:
   				RFX_Byte(pFX, ColArray[i].szFieldName, *(BYTE far *)lpColBuffer);
   				break;   
                      
				case SQL_SMALLINT:
					RFX_Int(pFX, ColArray[i].szFieldName, *(int far *)lpColBuffer);               
         		break;
         
      		case SQL_INTEGER:
      			RFX_Long(pFX, ColArray[i].szFieldName, *(long far *)lpColBuffer);   
         		break;
                                                                 
   			case SQL_BINARY:
   			case SQL_VARBINARY:
   				// case SQL_LONGVARBINARY:  See RFX_LongBinary below...                                                             
					RFX_Binary(pFX, ColArray[i].szFieldName, *(CByteArray far *)lpColBuffer, MAX_MEMO_SIZE);
         		break;   
         
      		case SQL_LONGVARBINARY:
      		case SQL_LONGVARCHAR:   
					RFX_LongBinary(pFX, ColArray[i].szFieldName, *(CLongBinary far *)lpColBuffer);              
         		break;
                     
				case SQL_REAL:                     
      			RFX_Single(pFX, ColArray[i].szFieldName, *(float far *)lpColBuffer);
      			break;
      	    
      		case SQL_DOUBLE:
      			RFX_Double(pFX, ColArray[i].szFieldName, *(double far *)lpColBuffer);
      			break;
      	
      		case SQL_DATE:
      		case SQL_TIME:
      		case SQL_TIMESTAMP:
      			RFX_Date(pFX, ColArray[i].szFieldName, *(CTime far *)lpColBuffer);
         		break;
              
      		// case SQL_LONGVARCHAR: See RFX_LongBinary() instead.
      		case SQL_CHAR:   
      		case SQL_VARCHAR:
      		case SQL_DECIMAL:
      		case SQL_NUMERIC:
         		RFX_Text(pFX, ColArray[i].szFieldName, *(CString far *)lpColBuffer, ColArray[i].Len + 1, ColArray[i].nSQLDataType);               
         		break;
			}         
      }   
   }                    
	CATCH_ALL(e)
	{
#ifdef _DEBUG
		CString msg("Error in DCustomRecordset::DoFieldExchange() with column ");
		msg += ColArray[i].szFieldName;                                       
		MessageBox(NULL, msg.GetBuffer(80), "Field Exchange Error", MB_ICONEXCLAMATION);
#endif			
	}
	END_CATCH_ALL
}