// dbdipdoc.h : interface of the DBDiplomatDoc class
//
/////////////////////////////////////////////////////////////////////////////
#if !defined(_DBDIPDOC_H)
	#define _DBDIPDOC_H 
#include "settypes.h"

class DBDiplomatDoc : public CDocument
{
protected: // create from serialization only
	DBDiplomatDoc();
	DECLARE_DYNCREATE(DBDiplomatDoc)

// Attributes
public:

	CString szGlobalSourcePath;
	CString szGlobalTargetPath;

	CString szGlobalSourceConnect;
	CString szGlobalTargetConnect;

	CString szGlobalTable;

	BOOL bDeleteDataFirst;
     
   int nGlobalSetUpId;

	CString szSettingsPath;
	
	int bSetupIsDirty;
	int bSetupIsNew;

	DBSETTINGS DBSettings;

	SETTINGSINFO MySettings; 

// Operations
public:            
	BOOL IsDirty(void) {  return bSetupIsDirty; }
	BOOL IsNew (void) { return bSetupIsNew; }
                    
	void MarkAsNewSetup(void) { bSetupIsDirty = FALSE; bSetupIsNew = TRUE; }
                    
	// Load and save functions are in DMainDlg. (No-serialized I/O here...)                    
	void SetDocumentName (CString& szDocName);
	              
	void SetupChanged(void) { bSetupIsDirty = TRUE; }
	void SetupIsClean(void) { bSetupIsDirty = FALSE; }
	void SetupIsNotNew(void) { bSetupIsNew = FALSE; }
                 
// Implementation
public:
	virtual ~DBDiplomatDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnNewDocument();

// Generated message map functions
protected:
	//{{AFX_MSG(DBDiplomatDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};    

#endif
/////////////////////////////////////////////////////////////////////////////
