// dbseting.cpp : implementation file
//

#include "stdafx.h"
#include "dbdiplom.h"
#include "dbdipdoc.h"
#include "dbseting.h"
#include "tools.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DBSettingsDlg dialog


DBSettingsDlg::DBSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(DBSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(DBSettingsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void DBSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DBSettingsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(DBSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(DBSettingsDlg)
	ON_BN_CLICKED(IDC_BROWSEBTN, OnBrowseBtnClick)
	ON_CBN_SELCHANGE(IDC_DBTYPESLIST, OnDBTypesListClick)
	ON_CBN_EDITCHANGE(IDC_DBTYPESLIST, OnDbTypesListEditChange)
	ON_BN_CLICKED(IDC_LOGINBTN, OnLoginBtnClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void DBSettingsDlg::EnableNonODBCOptions(void)
{
   GetDlgItem(IDC_DBPATHPROMPT)->EnableWindow(TRUE);
   GetDlgItem(IDC_BROWSEBTN)->EnableWindow(TRUE);
   GetDlgItem(IDC_DBPATH)->EnableWindow(TRUE);
   
   GetDlgItem(IDC_ODBCPROMPT1)->EnableWindow(FALSE);
   GetDlgItem(IDC_ODBCPROMPT2)->EnableWindow(FALSE);
   GetDlgItem(IDC_ODBCPROMPT3)->EnableWindow(FALSE);
   GetDlgItem(IDC_ODBCPROMPT4)->EnableWindow(FALSE);

   GetDlgItem(IDC_ODBCSERVER)->EnableWindow(FALSE);
   GetDlgItem(IDC_ODBCDATABASE)->EnableWindow(FALSE);
   GetDlgItem(IDC_ODBCUSERID)->EnableWindow(FALSE);
   GetDlgItem(IDC_ODBCPWD)->EnableWindow(FALSE);
   GetDlgItem(IDC_LOGINBTN)->EnableWindow(FALSE);
}

void DBSettingsDlg::EnableODBCOptions(void)                                    
{                         
   GetDlgItem(IDC_DBPATHPROMPT)->EnableWindow(FALSE);
   GetDlgItem(IDC_BROWSEBTN)->EnableWindow(FALSE);
   GetDlgItem(IDC_DBPATH)->EnableWindow(FALSE);
   
   GetDlgItem(IDC_ODBCPROMPT1)->EnableWindow(TRUE);
   GetDlgItem(IDC_ODBCPROMPT2)->EnableWindow(TRUE);
   GetDlgItem(IDC_ODBCPROMPT3)->EnableWindow(TRUE);
   GetDlgItem(IDC_ODBCPROMPT4)->EnableWindow(TRUE);

   GetDlgItem(IDC_ODBCSERVER)->EnableWindow(TRUE);
   GetDlgItem(IDC_ODBCDATABASE)->EnableWindow(TRUE);
   GetDlgItem(IDC_ODBCUSERID)->EnableWindow(TRUE);
   GetDlgItem(IDC_ODBCPWD)->EnableWindow(TRUE);
   GetDlgItem(IDC_LOGINBTN)->EnableWindow(TRUE);
} 

/////////////////////////////////////////////////////////////////////////////
// DBSettingsDlg message handlers

void DBSettingsDlg::OnBrowseBtnClick()
{                              
	CString szFileExts;
	CString szDefExt;	                                

	CString szConn; 
	char szTemp[256];
	
	GetDlgItemText(IDC_DBTYPESLIST, szTemp, 256);
	szConn = szTemp;	   
	   
	if(szConn == "MS Access Databases")
	{                                 
		szFileExts = "MS Access Databases (*.mdb) | *.mdb ||";
		szDefExt = "mdb";
	}
	else if(szConn == "dBase Files")
	{
		szFileExts = "dBase Files (*.dbf) | *.dbf ||";
		szDefExt = "dbf";
	}
	else if(szConn == "FoxPro Files")
	{
		szFileExts = "FoxPro Files (*.dbf) | *.dbf ||";
		szDefExt = "dbf";
	}
	else if(szConn == "Paradox Files")
	{
		szFileExts = "Paradox Files (*.db) | *.db ||";
		szDefExt = "db";
	}
	else 
	{
		szFileExts = "All Files (*.*) | *.* ||";
		szDefExt = "*";
	}
	
	CFileDialog BrowseDlg(TRUE, szDefExt, NULL, OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST,
   							szFileExts);
      
	CString szPath;      

	int rc = BrowseDlg.DoModal();
	if(rc)
	{
		// On success convert paths to upper-case
		szPath = BrowseDlg.GetPathName();	            
		                
		szPath.MakeUpper();		                
		
		SetDlgItemText(IDC_DBPATH, szPath);
	}
}

void DBSettingsDlg::OnDBTypesListClick()
{
	int nIndex = (int)SendDlgItemMessage(IDC_DBTYPESLIST, CB_GETCURSEL, 0, 0L);

   if (nIndex == 4)
      EnableODBCOptions();
   else
      EnableNonODBCOptions();                  
}

void DBSettingsDlg::OnDbTypesListEditChange()
{  
	CString szType;	                                         
	char szTemp[256];                      

	GetDlgItemText(IDC_DBTYPESLIST, szTemp, 256);   
	szType = szTemp;
   if (szType == "ODBC")
      EnableODBCOptions();
   else
      EnableNonODBCOptions();
}

BOOL DBSettingsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
                                                             
	pMyDoc = GetDoc();                                                             
	ASSERT(pMyDoc);
	if(!pMyDoc)
		return TRUE;                  
                                                             
	SetWindowText(pMyDoc->DBSettings.DlgCaption);
                                                 
	CComboBox *pCB = (CComboBox *)GetDlgItem(IDC_DBTYPESLIST);                                                 
   ASSERT(pCB);
   if(!pCB)
   	return TRUE;
                                                 
   pCB->AddString("MS Access Databases");
   pCB->AddString("dBase Files");
   pCB->AddString("FoxPro Files");
   pCB->AddString("Paradox Files");
   pCB->AddString("ODBC");

   SetDlgItemText(IDC_DBTYPESLIST, pMyDoc->DBSettings.CONN);
      
   if(pMyDoc->DBSettings.CONN == "ODBC")
   {
      EnableODBCOptions();
      SetDlgItemText(IDC_ODBCSERVER, pMyDoc->DBSettings.SERVR);
      SetDlgItemText(IDC_ODBCDATABASE, pMyDoc->DBSettings.DB);
      SetDlgItemText(IDC_ODBCUSERID, pMyDoc->DBSettings.USERID);
      SetDlgItemText(IDC_ODBCPWD, pMyDoc->DBSettings.PWD);
   }
   else
   {
      EnableNonODBCOptions();
      SetDlgItemText(IDC_DBPATH, pMyDoc->DBSettings.PATH);
   }
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void DBSettingsDlg::OnLoginBtnClick()
{             
	int rc;

   CDatabase DB;
	
   CString szConn;
   
	char szTemp[256];
                      
   szConn = "ODBC;DSN=";
   GetDlgItemText(IDC_ODBCSERVER, szTemp, 256);
	szConn += szTemp;  
                                          
   szConn += ";PWD=";                               
   GetDlgItemText(IDC_ODBCPWD, szTemp, 256);
	szConn += szTemp;  
                     
	szConn += ";UID=";
   GetDlgItemText(IDC_ODBCUSERID, szTemp, 256);
	szConn += szTemp;  
	
	szConn += ";Database=";	                    
   GetDlgItemText(IDC_ODBCDATABASE, szTemp, 256);
	szConn += szTemp;

	szConn += ";";

   rc = OpenDatabase(DB, szConn, TRUE);
   if(rc)
	{
      MessageBox("Log-In Successful!", "Log-In Success", MB_ICONINFORMATION);
      DB.Close();
   }
   // Failure message is done in OpenDatabase call!
}

void DBSettingsDlg::OnOK()
{    
	CString szConnType;             
	char szTemp[256];
	
	GetDlgItemText(IDC_DBTYPESLIST, szTemp, 256);
	szConnType = szTemp;
	
	if(szConnType.GetLength() == 0)
	{
		MessageBox("Select a database first!", "No Data Source Selected", MB_ICONEXCLAMATION);
	   return; 
	}
	   
  	if(szConnType == "ODBC") 
  	{
      pMyDoc->DBSettings.SQLSVR = TRUE;
                                 
		GetDlgItemText(IDC_DBTYPESLIST, szTemp, 256);                                 
      pMyDoc->DBSettings.CONN = szTemp;
	
		GetDlgItemText(IDC_DBPATH, szTemp, 256);                                 
      pMyDoc->DBSettings.PATH = szTemp;
      pMyDoc->DBSettings.PATH.MakeUpper();
   
  		GetDlgItemText(IDC_ODBCSERVER, szTemp, 256);                                 
      pMyDoc->DBSettings.SERVR = szTemp;

		GetDlgItemText(IDC_ODBCDATABASE, szTemp, 256);                                 
      pMyDoc->DBSettings.DB = szTemp;

		GetDlgItemText(IDC_ODBCUSERID, szTemp, 256);                                 
      pMyDoc->DBSettings.USERID = szTemp;

		GetDlgItemText(IDC_ODBCPWD, szTemp, 256);                                 
      pMyDoc->DBSettings.PWD = szTemp;
   }
   else
   {
      pMyDoc->DBSettings.SQLSVR = FALSE;
      
		GetDlgItemText(IDC_DBTYPESLIST, szTemp, 256);                                 
      pMyDoc->DBSettings.CONN = szTemp;

		GetDlgItemText(IDC_DBPATH, szTemp, 256);                                 
      pMyDoc->DBSettings.PATH = szTemp;  

      pMyDoc->DBSettings.SERVR = "";
      pMyDoc->DBSettings.DB = "";
      pMyDoc->DBSettings.USERID = "";
      pMyDoc->DBSettings.PWD = "";
   }

	EndDialog(TRUE);
}

void DBSettingsDlg::OnCancel()
{
	EndDialog(FALSE);
}
