// dmaindlg.cpp : implementation file
//

#include "stdafx.h"
#include "dbdiplom.h"
#include "dbdipdoc.h"
#include "setngrec.h"
#include "xlatflds.h"
#include "tablinfo.h"
#include "variant.h"  
#include "dmaindlg.h"         
#include "opnsetup.h"
#include "savsetup.h"
#include "dbseting.h"  
#include "setupdsc.h"
#include "srcsql.h"   
#include "tools.h"   
#include "custrecs.h"
#include <direct.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
                               
const CString szNoFoxProHelp("Make sure path is correct and that the FoxPro 2.5 ODBC driver is installed on your system under a data source named 'FoxPro Files'.");                               
                               
/////////////////////////////////////////////////////////////////////////////
// DMainDlg

IMPLEMENT_DYNCREATE(DMainDlg, CFormView)

DMainDlg::DMainDlg()
	: CFormView(DMainDlg::IDD)
{
	nEditIndex = -1;
	bCanEditRule = FALSE;
	bCanEditData = FALSE;       

  	bConversionDataEnabled = FALSE;
	                                        
	pMyDoc = NULL;
	pMySettings = NULL;
                  
	//{{AFX_DATA_INIT(DMainDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

DMainDlg::~DMainDlg()
{
}

void DMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DMainDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(DMainDlg, CFormView)
	//{{AFX_MSG_MAP(DMainDlg)
	ON_COMMAND(IDM_SOURCEDBSETTINGS, OnChangeSrcDBSettings)
	ON_COMMAND(IDM_TARGETDBSETTINGS, OnChangeTargetDBSettings)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(IDM_CUSTOMSRCSQL, OnEditCustomSrcSQL)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(IDM_ADDALLTARGETCOLS, OnAddAllTargetCols)
	ON_COMMAND(IDM_BIND, OnBind)
	ON_COMMAND(IDM_BINDALL, OnBindAll)
	ON_COMMAND(IDM_BINDALLFORWARD, OnBindAllForward)
	ON_COMMAND(IDM_CHANGESETUPPATH, OnChangeSetUpPath)
	ON_COMMAND(IDM_EDITSETUPDESC, OnEditSetupDesc)
	ON_COMMAND(IDM_EMPTYTARGET, OnToggleEmptyTargetOption)
	ON_COMMAND(IDM_TRANSFERDATA, OnTransferData)
	ON_COMMAND(IDM_UNBIND, OnUnbind)
	ON_COMMAND(IDM_UNBINDALL, OnUnbindAll)
	ON_LBN_SELCHANGE(IDC_BOUNDCOLUMNSLIST, OnBoundColumnsListClick)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_EN_CHANGE(IDC_CONVERSIONDATA, OnConversionDataChange)
	ON_EN_SETFOCUS(IDC_CONVERSIONDATA, OnConversionDataSetFocus)
	ON_EN_KILLFOCUS(IDC_CONVERSIONDATA, OnConversionDataKillFocus)
	ON_CBN_SELCHANGE(IDC_CONVERSIONRULELIST, OnConversionRuleListClick)
	ON_CBN_SETFOCUS(IDC_CONVERSIONRULELIST, OnConversionRuleListSetFocus)
	ON_CBN_KILLFOCUS(IDC_CONVERSIONRULELIST, OnConversionRuleListKillFocus)
	ON_CBN_SELCHANGE(IDC_SOURCETABLESLIST, OnSourceTablesListClick)
	ON_CBN_SELCHANGE(IDC_TARGETTABLESLIST, OnTargetTablesListClick)
	ON_BN_CLICKED(IDC_CHANGESOURCEBTN, OnChangeSourceBtnClick)
	ON_BN_CLICKED(IDC_CHANGETARGETDBBTN, OnChangeTargetDBBtnClick)
	ON_BN_CLICKED(IDC_BINDBTN, OnBindBtnClick)
	ON_BN_CLICKED(IDC_UNBINDBTN, OnUnbindBtnClick)
	ON_BN_CLICKED(IDC_UNBINDALLBTN, OnUnbindAllBtnClick)
	ON_BN_CLICKED(IDC_BINDALLFORWARDBTN, OnBindAllFwdBtnClick)
	ON_BN_CLICKED(IDC_BINDALLBTN, OnBindAllBtnClick)
	ON_BN_CLICKED(IDC_ADDALLTARGETCOLSBTN, OnAddAllTargColsBtnClick)
	ON_BN_CLICKED(IDC_TRANSFERDATABTN, OnTransferDataBtnClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
                 
                 
int DMainDlg::AddConvTupleToList(int nConvLB, int nSrcLB, int nTargLB, int nSourceLBIndex, int nTargetLBIndex, int nIndex)
{        
	int nSrcType;
   int nSrcLen;
   int nDestType;
   int nDestLen;
    
   int nNew; 
    
   CString szRule;
   CString szConvData;
   CString szEntry;

   CString szSourceCol;
   CString szTargetCol;
   
  	CListBox *pSrcLB = NULL;
  	CListBox *pTargLB = NULL;
   
	DWORD dwItemData;                                                
                  
	pSrcLB = (CListBox *)GetDlgItem(nSrcLB);                  
	pTargLB = (CListBox *)GetDlgItem(nTargLB);                  
                             
	ASSERT(pSrcLB);
	ASSERT(pTargLB);
                                                
   if (nSourceLBIndex != 9999) 
   {                
   	dwItemData = pSrcLB->GetItemData(nSourceLBIndex);
      nSrcType = (int)HIWORD(dwItemData);
      nSrcLen = (int)LOWORD(dwItemData);
   }
   else
      nSrcType = -1;

  	dwItemData = pTargLB->GetItemData(nTargetLBIndex);
   nDestType = (int)HIWORD(dwItemData);
   nDestLen = (int)LOWORD(dwItemData);
   
   // Load convert rule...
   szRule = GuessConvertRule(nDestType, nDestLen, nSrcType, nSrcLen, szConvData);
   if (nSourceLBIndex != 9999) 
   {
   	pSrcLB->GetText(nSourceLBIndex, szSourceCol);
   }
   else
      szSourceCol = "(N.A.)";
                     
	// Target string to temp. buffer.                     
  	pTargLB->GetText(nTargetLBIndex, szTargetCol);
   	   
   szEntry = szSourceCol;
   szEntry += "  ===>  ";
   szEntry += szTargetCol;
	szEntry += " [";
	szEntry += szRule;
	if (szConvData.GetLength() > 0) 
	{
      szEntry += ", ";
      szEntry += szConvData;
   }

   szEntry += "]";

   if (nIndex == -1) 
   {
      // Append item to list;
      nNew = (int)SendDlgItemMessage(nConvLB, LB_ADDSTRING, 0, (LPARAM)(LPSTR)szEntry.GetBuffer(256));
		if(nNew > -1)                            
		{
			dwItemData = MAKELONG(nTargetLBIndex, nSourceLBIndex);
			SendDlgItemMessage(nConvLB, LB_SETITEMDATA, nNew, (LPARAM)dwItemData);
   	}
   }
   else
   {
      // Update item in list -- First insert, then delete old one.
		SendDlgItemMessage(nConvLB, WM_SETREDRAW, 0, 0L);
   	nNew = (int)SendDlgItemMessage(nConvLB, LB_INSERTSTRING, nIndex, (LPARAM)(LPSTR)szEntry.GetBuffer(256));
      if(nNew > -1)
      {                                        
      	dwItemData = MAKELONG(nTargetLBIndex, nSourceLBIndex);
			SendDlgItemMessage(nConvLB, LB_SETITEMDATA, nNew, (LPARAM)dwItemData);
	   	SendDlgItemMessage(nConvLB, LB_DELETESTRING, nNew + 1, 0L);
      }
   	SendDlgItemMessage(nConvLB, WM_SETREDRAW, 1, 0L);
	}
	return nNew;
}
      
int DMainDlg::DumpColumnLBToColumnArray(int nLBID, COLUMNINFO **pMyArray)
{      
	CListBox *pLB = (CListBox *)GetDlgItem(nLBID);
	ASSERT(pLB);
      
   DWORD dwItemData;    
   int p;
      
   CString szEntry;   
	int nCols = pLB->GetCount();
		         
	COLUMNINFO *pArray = new COLUMNINFO[nCols]; 
   if(!pArray)   
   	return 0;
      
	for(int i = 0; i < nCols; i++)
	{  
		pLB->GetText(i, szEntry);

		// Get field name...		
		p = szEntry.Find(" (");
		if(p > -1)
			szEntry = szEntry.Left(p);	
#ifdef _DEBUG			 
		else	 
			MessageBox("Warning: Field name may be incorrectly parsed.",
						  "Parsing Warning", MB_ICONEXCLAMATION);
#endif		
		pArray[i].szFieldName = szEntry;
	
	  	dwItemData = pLB->GetItemData(i);
   	pArray[i].nSQLDataType = (int)HIWORD(dwItemData);
   	pArray[i].Len = (int)LOWORD(dwItemData);

		pArray[i].ColData.eType = MapSQLTypeToEnumRFXType(pArray[i].nSQLDataType);
	}                                                                  
	*pMyArray = pArray;	
		
	return i;  // Return # of records filled in...
}      

int DMainDlg::DumpBoundColsLBToBoundColsArray(int nLBID, BOUNDCOLUMNSINFO **pMyArray)
{      
	CListBox *pLB = (CListBox *)GetDlgItem(nLBID);
   ASSERT(pLB);
      
   DWORD dwItemData;    
      
   CString szEntry;   
	CString szRule;
	CString szData;
	int nCols = pLB->GetCount();
		         
	BOUNDCOLUMNSINFO *pArray = new BOUNDCOLUMNSINFO[nCols]; 
   if(!pArray)   
   	return 0;
      
	for(int i = 0; i < nCols; i++)
	{                             
	  	dwItemData = pLB->GetItemData(i);
   	pArray[i].nSourceCol = (int)HIWORD(dwItemData);
   	pArray[i].nTargetCol = (int)LOWORD(dwItemData);
	
		pLB->GetText(i, szEntry);
                  
      GetConvRuleFromEntry(szEntry, szRule, szData);
      
      pArray[i].eConvRule = MapStringToEnumConvType(szRule);
      pArray[i].szConvData = szData;
	}
   *pMyArray = pArray;
	
	return i;  // Return # of records filled in...
}      
                  
long DMainDlg::DoDataTransfer (SETTINGSINFO& Settings, CString& szMySettingsPath, int bDelTargetFirst, 
                              int nBoundColsList, int nStatus)
{     
	CDatabase SrcDB;
	CDatabase TargetDB;
                           
	// Array to hold our records...                           
   BOUNDCOLUMNSINFO *BoundColsArray = NULL;
   COLUMNINFO *SrcColsArray = NULL;
   COLUMNINFO *TargColsArray = NULL;
      
   CString msg;
   
   int rc;     
   int j;       

	long lCount = 0L;                               
            
	char szTemp[256];
                               
	int nSourceCol;
	int nTargetCol;
      
   int nSrcCols;
   int nTargCols;      
      
   int nStep = 0;                  
                               
	int bCouldNotDelete = FALSE;                               
    
   long lUpdates = 0L; 
                               
   CString szSQL;               
	CString szSrcSQL;
	CString szTargSQL;	      
	                  
   CVariant Dummy;
   
	int nBoundCols = (int)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETCOUNT, 0, 0L);
	
	if(nBoundCols == 0)
	{
		MessageBox("Select some bound columns to import first!", "No Bound Columns", MB_ICONEXCLAMATION);
		return 0;
	}
	
	rc = MessageBox("Start data transfer now?", "Transfer Data", MB_ICONQUESTION | MB_YESNO);
   if(rc != IDYES) 
      return 0;
             
   if(pMyDoc->bDeleteDataFirst == TRUE)                                           
   {                                                                            
   	msg = "Are you sure you want to delete all records in target table ";
   	msg += Settings.DEST_TABLE;
   	msg += "?";
      rc = MessageBox(msg, "Confirm Data Loss", MB_ICONEXCLAMATION | MB_YESNOCANCEL);
      if(rc != IDYES)
		{		      
         SayThis("(Data transfer cancelled.)");
			return 0;
      }                                      
   }
    
   ShowWaitCursor();
   
   SayThis("Initializing...");

   // Open source and target DB sources...
   rc  = OpenDatabase(SrcDB, pMyDoc->szGlobalSourceConnect, TRUE);
   if(!rc)
	{
      ShowArrowCursor();
      SayThis("(Data transfer stopped--Can't open source.)");
      return 0L;
	}
   
   rc = OpenDatabase(TargetDB, pMyDoc->szGlobalTargetConnect, TRUE);
   if(!rc)
   {
    	SrcDB.Close();
      ShowArrowCursor();
      SayThis("(Data transfer stopped--Can't open target.)");
		return 0L;
	}
                
	// Otherwise, both DB's are open.
	TRY
	{                                                  
		if(pMyDoc->bDeleteDataFirst)
		{
			// First, delete all records for this project.  
			// ***Note***!!! ODBC API here instead because CDatabase::ExecuteSQL() does not work for FoxPro ISAM DB.!!!
			SayThis("Deleting records from target table...");

   		szSQL = "DELETE FROM ";
   		szSQL += NoTableOwner(pMyDoc->MySettings.DEST_TABLE);
      
	      HSTMT hstmt;
      
			rc = SQLAllocStmt(TargetDB.m_hdbc, &hstmt);
			              
			if(rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO)
			{
	   		bCouldNotDelete = TRUE;
			}	           
			else
			{	
				ASSERT(hstmt);
	   
				rc = SQLExecDirect(hstmt, (UCHAR far *)szSQL.GetBuffer(256), szSQL.GetLength());
				if(rc != SQL_SUCCESS)
				{
#ifdef _DEBUG		                                       
					UCHAR szSQLState[256];                              
					UCHAR szError[256];                              
					SDWORD dwErrCode;  
					SWORD wRetBytes;
					int nErr = SQLError(NULL, NULL, hstmt, szSQLState, &dwErrCode, szError, 256, &wRetBytes);
					MessageBox((LPSTR)szError, "SQL Error =");
#endif			
					msg = "Warning: Can't delete records from XLATFLDS.DBF.  (This is probably a limitation of the ODBC FoxPro driver.  Try saving to a new Set-Up I.D. using 'File | Save As' instead.";
					MessageBox(msg, "Can't Delete", MB_ICONEXCLAMATION);
					SayThis("(Couldn't delete.)");
					bCouldNotDelete = TRUE;
				}
			}	
			SQLFreeStmt(hstmt, SQL_DROP);

			if(bCouldNotDelete)
			{
				msg = "Unable to delete records from Table ";
				msg += NoTableOwner(pMyDoc->MySettings.DEST_TABLE);
         	msg += ".  Continue anyway?";
     			ShowArrowCursor();
          	rc = MessageBox(msg, "", MB_ICONQUESTION | MB_YESNOCANCEL);
         	if(rc != IDYES)
         	{
			    	SrcDB.Close();
      			TargetDB.Close();
      			ShowArrowCursor();
      			SayThis("(Data transfer stopped.)");
					return 0L;
				}
				else
	     			ShowWaitCursor();
			}          	                     
		}
   	// Load source and target column information.                                   
   	// (We're cheating here--the U.I. listbox stores the column names and data types.)
 		nSrcCols = DumpColumnLBToColumnArray(IDC_SOURCECOLUMNSLIST, &SrcColsArray);
      nTargCols = DumpColumnLBToColumnArray(IDC_TARGETCOLUMNSLIST, &TargColsArray);

      // Now create a custom record set that will work with each of our tables...
		// Tell our DCustomRecordset objects about our column information.
		DCustomRecordset snSrc(&SrcDB, SrcColsArray, nSrcCols);
		DCustomRecordset dsTarg(&TargetDB, TargColsArray, nTargCols);	

		// Now write Bound columns info. to array in memory.      
		nBoundCols = DumpBoundColsLBToBoundColsArray(IDC_BOUNDCOLUMNSLIST, &BoundColsArray);
				
		// Now open our recordsets.
	   // Use custom SQL string for source, if provided...
	   if(pMyDoc->MySettings.SRC_SQL.GetLength() > 0)
			szSrcSQL = pMyDoc->MySettings.SRC_SQL;
		else
		{
	      szSrcSQL = "SELECT * FROM ";
	      szSrcSQL += NoTableOwner(pMyDoc->MySettings.SRC_TABLE);
	   }   
      
      // Target SQL
      szTargSQL = "SELECT * FROM ";
      szTargSQL += NoTableOwner(pMyDoc->MySettings.DEST_TABLE);

		snSrc.Open(CRecordset::snapshot, szSrcSQL);
		dsTarg.Open(CRecordset::snapshot, szTargSQL);
		   
		snSrc.MoveFirst();                       
		
		int bContinue = TRUE;
		while(snSrc.IsEOF() == FALSE && bContinue)
		{
			TRY
			{           
				msg = "Converting record #";
				msg += ltoa(lCount + 1, szTemp, 10);                            
				msg += "...";
				SayThis(msg);
				nStep = 1;
				dsTarg.MoveFirst();
				nStep = 2;
				dsTarg.AddNew();		              

				nStep = 3;				
				// Now fill-in data in variables in new record.
				for(j = 0; j < nBoundCols; j++)
				{
					nSourceCol = BoundColsArray[j].nSourceCol;								                                            	
				   nTargetCol = BoundColsArray[j].nTargetCol;
				   
				   if(nSourceCol < 9999 && nSourceCol > -1)
				   	// We don't need a source column for 'BlankValue' or 'StuffValue'.
			   		rc = TargColsArray[nTargetCol].ColData.ConvertData(SrcColsArray[nSourceCol].ColData, BoundColsArray[j].eConvRule, BoundColsArray[j].szConvData);
               else
               	rc = TargColsArray[nTargetCol].ColData.ConvertData(Dummy, BoundColsArray[j].eConvRule, BoundColsArray[j].szConvData);
					if(!rc)
					{                               
						msg = "Unable to convert field ";
						msg += SrcColsArray[j].szFieldName;
						msg += " to ";
						msg += TargColsArray[j].szFieldName;          
						msg += ".  You should verify that your list of bound columns is correct.  Continue anyway?";
						ShowArrowCursor();
						rc = MessageBox (msg, "Can't Convert Field", MB_ICONEXCLAMATION | MB_ICONQUESTION);						
					   if(rc != IDYES)
					   {        
					   	bContinue = FALSE;
					   	continue;	
					   } 
					   else
					   {  
					   	// Skip ahead to next record.
					   	ShowWaitCursor();
					      nStep = 5;   
							lCount++;
							snSrc.MoveNext();		                                               
							continue;
					   }	
					}
		      }
		      nStep = 4;
		      dsTarg.Update();
		      lUpdates++;  // Success for this record!
		   }      
			CATCH(CDBException, e)
			{	
				// Process errors
				if(nStep == 1)
				{                  
					msg = "Error repositioning target table. (Error =";
				}
				else if(nStep == 2)                          
				{         
					msg = "Error adding new record to target table. (Error =";
				}
				else if(nStep == 3)
				{ 
					msg = "Error while converting data using bound columns. (Error ="; 
				}
				else if(nStep == 4)
				{ 
					msg = "Error updating record in target table. (Error ="; 
				}
				else // Other error
				{
					msg = "Unspecified error while processing this record. (Error =";
				}       
				msg += e->m_strError;
				msg += ") Continue anyway?";
				rc = MessageBox(msg, "Can't Convert Record", MB_ICONEXCLAMATION | MB_YESNOCANCEL);
				if(rc != IDYES)
				{
				  	bContinue = FALSE;
				  	continue;	
				}              
				else
				{
					ShowWaitCursor();	
				}
			}
			END_CATCH
			while(1)  // Loop to get new record in source DB.
			{
				TRY
				{
					nStep = 5;   
					lCount++;
					snSrc.MoveNext();		                                               
					break;
				}	
           	CATCH(CDBException, e)
           	{
					msg = "Error repositioning source table. (Error =";
					msg += e->m_strError;
					msg += ") Continue anyway?";
					rc = MessageBox(msg, "Can't Convert Record", MB_ICONEXCLAMATION | MB_YESNOCANCEL);
					if(rc != IDYES)
					{
					  	bContinue = FALSE;
				  		continue;	
					}              
					else
					{
					   ShowWaitCursor();
					}
	        	} 
           	END_CATCH
         }	
		}

		// Now do clean-up...
		delete[] BoundColsArray;
		delete[] TargColsArray;
      delete[] SrcColsArray;       
      TRY
      {                
      	if(snSrc.IsOpen())
				snSrc.Close();
			if(dsTarg.IsOpen())
				dsTarg.Close();	
			SrcDB.Close();
			TargetDB.Close();
		}
		CATCH_ALL(e)
		{
			// Do nothing...		
		}
		END_CATCH_ALL	
		return lUpdates;
	}
	CATCH(CDBException, e)  
	{  
		// This CATCH block should be reached only on 'fatal' init. error.
		// Per-record errors should be processed above and should allow the
		// user to continue.
		if(SrcDB.IsOpen())
			SrcDB.Close();
		if(TargetDB.IsOpen())
			TargetDB.Close();
		ShowArrowCursor();      
		msg = "Can't open source and target tables. (Error=";
		msg += e->m_strError;
		msg += ")";
		MessageBox(msg, "Can't Open Tables", MB_ICONEXCLAMATION);
	}
	END_CATCH_ALL
	return lUpdates;
}	                               

void DMainDlg::GetConvRuleFromEntry (CString& szEntry, CString& szRule, CString& szData)
{
 	int p1;
   int p2;

   CString szConvRaw;
   
   CString Temp;
   
   p1 = szEntry.Find("[");
   if (p1 == -1)  
   {
      szEntry = "";
      szRule = "";
      return;
   }
   
	Temp = szEntry.Mid(p1 + 1);   
   
   p2 = Temp.Find("]");
   if (p2 == -1) 
   {
      szEntry = "";
      szRule = "";
      return;
   }
      
   szConvRaw = szEntry.Mid(p1 + 1, p2);
   
   p1 = szConvRaw.Find(",");
   if (p1 == -1) 
   {
      szRule = szConvRaw;
      szData = "";
   }   
   else
   {
      szRule = szConvRaw.Mid(0, p1);
      szData = szConvRaw.Mid(p1 + 2);
   }	
}

CString& DMainDlg::GetDataTypeAsStr(int nType, int nLen)
{        
	static CString szType("");    
  	// (Define's in SQL.H)
	//#define SQL_CHAR				1
	//#define SQL_NUMERIC 			2
	//#define SQL_DECIMAL 			3
	//#define SQL_INTEGER 			4
	//#define SQL_SMALLINT			5
	//#define SQL_FLOAT				6
	//#define SQL_REAL				7
	//#define SQL_DOUBLE				8
	//#define SQL_VARCHAR 			12
   
   // (Defines in SQLEXT.H)                    
	//#define SQL_DATE				 9
	//#define SQL_TIME				10
	//#define SQL_TIMESTAMP			11
	//#define SQL_LONGVARCHAR 		(-1)
	//#define SQL_BINARY				(-2)
	//#define SQL_VARBINARY			(-3)
	//#define SQL_LONGVARBINARY	(-4)
	//#define SQL_BIGINT				(-5)
	//#define SQL_TINYINT 			(-6)
	//#define SQL_BIT 				(-7)
                       
   CString s;
   CString l; 

   l = ToStr(nLen);
   
 	switch(nType)
 	{
      case SQL_BIT:
         s = "F" + l;
         break;
      case SQL_SMALLINT:
      case SQL_INTEGER:
         s = "I" + l;
         break;
      case SQL_FLOAT:
      case SQL_DOUBLE:
      case SQL_REAL:
      case SQL_DECIMAL:
         s = "N" + l;
         break;
      case SQL_DATE:
         s = "D" + l;
         break;
      case SQL_TIME:
      case SQL_TIMESTAMP:
         s = "T" + l;
         break;
      case SQL_VARCHAR:
      case SQL_CHAR:
  	   case SQL_NUMERIC:
  
         s = "A" + l;
         break;
      case SQL_BINARY:
      case SQL_VARBINARY:
      case SQL_LONGVARBINARY: 
      case SQL_LONGVARCHAR:
         s = "M";
         break;
		default:     
         s = "?" + l;      
#ifdef _DEBUG   
			CString msg;
			msg = "Unrecognized SQL data type = ";
			msg += ToStr(nType);
			msg += "in DMainDlg::GetDataTypeAsStr()!"; 
			MessageBox(msg, "Warning!", MB_ICONEXCLAMATION);			
#endif		
	}
	szType = s;         
	
	return szType;
}                 

int DMainDlg::GetNewSetUpId (CString& SettingsPath)
{
   // Returns unique set-up I.D.
   CDatabase DB;
                         
   int nLastId;
   int nNewId;
	int rc;        
            
	CString szConn = "ODBC;DSN=FoxPro Files;DBQ=";
	szConn += SettingsPath;
	szConn += "\\SETTINGS.DBF";
   
   rc = OpenDatabase(DB, szConn);
  	if(!rc)
   	return -1;
	TRY
	{  
	   DSettingsRecordset sn(&DB);                               
      rc = sn.Open(CRecordset::snapshot, "SELECT * FROM SETTINGS ORDER BY SETUPID");
 		if (!rc)
   	{
      	DB.Close();
      	return -1;
      }   
            
      sn.MoveLast();
      nLastId = -1;
      nLastId = (int)sn.m_SETUPID;
      nNewId = nLastId + 1;
      sn.Close();
      DB.Close();
      return nNewId;
   }      
	CATCH(CDBException, e)
   {
   	MessageBox(e->m_strError, "Can't Access Table SETTINGS.DBF", MB_ICONEXCLAMATION);
#ifdef _DEBUG   
   	MessageBox(e->m_strStateNativeOrigin, "DB ODBC Error");
#endif		         
		if(DB.IsOpen())
			DB.Close();	
   	return -1;
   }	   
	END_CATCH       
	return -1;
}
             
CString& DMainDlg::GuessConvertRule (int nDestType, int nDestLen, int nSrcType, int nSrcLen, CString& szConvData)
{        
	static CString szOutStr("");
   // Guess best conversion rule
   CString szRule;
   int bSrcIsText;
   int bSrcIsNum;
   int bDestIsText;
   int bDestIsNum; 

   //"Copy"
   //"StuffValue"
   //"BlankValue"
   //"LeftTrim"
   //"RightTrim"
   //"ToNumber"
   //"ToString"
   //"YesNoToLogical"
   //"LogicalToYesNo"
   
   // (Grunge programming here...)
   if (nSrcType == -1) 
   {
   	szOutStr = "BlankValue";
      return szOutStr;
   }

   bSrcIsNum = IsNumberType(nSrcType);
   bDestIsNum = IsNumberType(nDestType);

   bSrcIsText = IsTextType(nSrcType);
   bDestIsText = IsTextType(nDestType);

   szConvData = "";
   
   if (nDestType == nSrcType) 
   {
      if (nDestLen < nSrcLen)                
      {
         szRule = "LeftTrim";
         szConvData = ToStr(nDestLen);
      }        
      else
         szRule = "Copy";
   }   
   else if (bSrcIsNum && bDestIsText) 
      szRule = "ToString";
   else if (bSrcIsText && bDestIsNum) 
      szRule = "ToNumber";
   else if (nDestType == SQL_CHAR && nDestLen == 1 && nSrcType == SQL_BIT) 
      szRule = "LogicalToYesNo";
   else if (nSrcType == SQL_CHAR && nSrcLen == 1 && nDestType == SQL_BIT) 
      szRule = "YesNoToLogical";
   else
      // Default...
      szRule = "Copy";
   
	szOutStr = szRule;                                                   
	
	return szOutStr;
}
                              
                              
int DMainDlg::CopyLBEntryToXlatFlds(XLATFLDS& ThisRec, CString& szEntry, int nMySetUpId, int nOrder)
{
   // Parse out fields in szEntry to record.
   int p;
   int q;
   int r;
   int s;

   CString s1;
   CString s2;
   CString s3;      

	CString msg;
         
   int bOk;
  
   ThisRec.Clear();

   ThisRec.SETUPID = nMySetUpId;
   ThisRec.FIELDORDER = nOrder;
   
   // Get convert rule
   GetConvRuleFromEntry(szEntry, ThisRec.CONV_RULE, ThisRec.CONV_DATA);

   // Walk-through string
   s1 = szEntry;

   bOk = FALSE;

   while (TRUE) // for error control
   {
      p = s1.Find("N.A.");
      if (p != -1)
		{
         ThisRec.SRC_FIELD = "";
         ThisRec.SRC_TYPE = "";
         ThisRec.SRC_LEN = 0;
 		}        
 		else
 		{
      	s = s1.Find("(");
      	if (s == -1)
      		break;
		   ThisRec.SRC_FIELD = s1.Mid(0, s - 1);
     		s3 = s1.Mid(s + 1);
         q = s3.Find(")");
         if(q == -1)
         	break;
         
         ThisRec.SRC_TYPE = s3.Mid(0, 1);
         s2 = s3.Mid(1, q - 1);
         ThisRec.SRC_LEN = atoi(s2.GetBuffer(40));
      }
      
      p = s1.Find("> ");
      if (p == -1)
      	break;
    
    	s3 = s1.Mid(p + 2);
      q = s3.Find("(");
      s2 = s3.Mid(1, q - 2);
      //Trim s2?
      
      ThisRec.DEST_FIELD = s2;
                              
      s3 = s3.Mid(q + 1);                        	
      r = s3.Find(")");                      
      if (r == -1)
      	break;

      ThisRec.DEST_TYPE = s3.Mid(0, 1);
     	if(r < 2)
     		s2 = s3.Mid(1, 1);
     	else
     		s2 = s3.Mid(1, r - 1);	
      ThisRec.DEST_LEN = atoi(s2.GetBuffer(40));

      bOk = TRUE;
      break;
   }

   if (!bOk)
   {
   	msg = "Warning: Problem parsing '";
   	msg += szEntry;
   	msg += "'.";
      MessageBox(msg, "Not Parsed", MB_ICONEXCLAMATION);
      return FALSE;
   }   
   else
      return TRUE;
}
                              
                              
void DMainDlg::LoadConversionRules (int nThisLBID)
{                                            
   CComboBox *pCB = (CComboBox *)GetDlgItem(nThisLBID);
   	       
	ASSERT(pCB);   	       
   	       
	if(!pCB)   	
		return;
   	
   // You can add your own custom conversion rules, too...
   pCB->ResetContent();
   pCB->AddString("Copy");
   pCB->AddString("StuffValue");
   pCB->AddString("BlankValue");
   pCB->AddString("LeftTrim");
   pCB->AddString("RightTrim");
   pCB->AddString("ToNumber");
   pCB->AddString("ToString");
   pCB->AddString("YesNoToLogical");
   pCB->AddString("LogicalToYesNo");
}
                       
int DMainDlg::LoadTableColumns (int nLBID, CString& szConnect, CString& szTable)
{   
   CDatabase DB;
      
	int rc;        

   CString szEntry;
   CString msg;
   int nType;
   int nSize;
                
	int nNew;                

	DWORD dwItemData;
              
	CListBox *pThisLB = (CListBox *)GetDlgItem(nLBID);                 
   if(!pThisLB)
   	return FALSE;

   ShowWaitCursor();

	pThisLB->ResetContent();

   rc = OpenDatabase(DB, szConnect);
  	if(!rc)
  	{
   	ShowArrowCursor();
   	return FALSE;
   }		         
	
	TRY
	{  
	   DTableInfoRecordset ColInfo(&DB); 
	   
	   // Get information about this table...        	
		ColInfo.m_strTableNameParam = NoTableOwner(szTable);
      
      rc = ColInfo.Open();
 		if (!rc)
   	{
      	DB.Close();
      	ShowArrowCursor();
      	return FALSE;
      }   
      
		// Otherwise, walk through the columns for this table...      
      ColInfo.MoveFirst();
      while(ColInfo.IsEOF()==FALSE)
      {
      	szEntry = ColInfo.m_strColumnName;
      	nType = ColInfo.m_nDataType;
      	
      	nSize = (int)ColInfo.m_lLength;
                                  
      	szEntry += " (";
      	szEntry += GetDataTypeAsStr(nType, nSize);
      	szEntry += ")";

      	nNew = pThisLB->AddString(szEntry);
      	// Pack field type and size in the listbox's ItemData.
      	if(nNew > -1)    
      	{
      		dwItemData = MAKELONG(nSize, nType);  
      		pThisLB->SetItemData(nNew, dwItemData); 
   		}
   		ColInfo.MoveNext();
   	}     
   	ColInfo.Close();
   	DB.Close();
	   ShowArrowCursor();                  
	   return TRUE;
   }      
	CATCH(CDBException, e)
   {  
   	msg = "Can't Read Columns for Table ";
   	msg += szTable;
   	msg += " (Error = ";
   	msg += e->m_strError;
   	msg += ")";
   	MessageBox(msg, "Can't Read Columns", MB_ICONEXCLAMATION);
#ifdef _DEBUG   
   	MessageBox(e->m_strStateNativeOrigin, "DB ODBC Error");
#endif
		if(DB.IsOpen())
			DB.Close();	
   	return FALSE;
   }	   
	END_CATCH        
	return FALSE;
}

#define STR_LEN 128+1
#define REM_LEN 254+1
                    
BOOL DMainDlg::FillCBWithTableNames(int nCBID, CString& szConnect)
{                              
  	// ***Requires ODBC SQL API SQLTables() call.***
	CDatabase DB;                     
		
   int rc;
         
	CString szEntry;         
                       
   CComboBox *pCB = (CComboBox  *)GetDlgItem(nCBID);
      
   if(!pCB)
   	return FALSE;
   
   ShowWaitCursor();
   	
   pCB->ResetContent();	
      
	rc = OpenDatabase(DB, szConnect);
	if(!rc)              
	{
		ShowArrowCursor();
		return FALSE;
   }
          
	HSTMT hstmt;                                     

	rc = SQLAllocStmt(DB.m_hdbc, &hstmt);
	
	if(rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO)
	{
	   if(DB.IsOpen())
			DB.Close();
		return FALSE;
	}	           
	
	// Storage locations for result set.          
	UCHAR  szQualifier[STR_LEN], szOwner[STR_LEN];
	UCHAR  szTableName[STR_LEN]; 
	// UCHAR szColName[STR_LEN];
	UCHAR  szTypeName[STR_LEN], szRemarks[REM_LEN];
	SDWORD Precision, Length;
	SWORD  DataType, Scale, Radix, Nullable;

	// Declare storage locations for bytes available to return.

	SDWORD cbQualifier, cbOwner, cbTableName;
	// SDWORD cbColName;
	SDWORD cbTypeName, cbRemarks, cbDataType, cbPrecision;

	SDWORD cbLength, cbScale, cbRadix, cbNullable;
   	
	// SQLTables returns the following recordset...                     
	//TABLE_QUALIFIER	Varchar(128)	Table qualifier identifier; NULL if not applicable to the data source.
	//TABLE_OWNER		Varchar(128)	Table owner identifier; NULL if not applicable to the data source.
	//TABLE_NAME		Varchar(128)	Table identifier.
	//TABLE_TYPE		Varchar(128)	Table type identifier; one of the following: "TABLE", "VIEW", "SYSTEM TABLE", "ALIAS", "SYNONYM" or a data source specific type identifier.
	//REMARKS			Varchar(254)	A description of the table.                     
   
   // Storage locations for bytes available to retrieve.
	
   char szTableTypes[30] = "'TABLE','SYSTEM TABLE'";                     
   ASSERT(hstmt);	                      
   rc = SQLTables(hstmt,   	// hstmt
						NULL, 		  	// szTableQualifier, 
						0,				  	// cbTableQualifier, 
						NULL,			  	// szTableOwner,
						0,				  	// cbTableOwner, 
						NULL, 		  	// szTableName, 
						0,				  	// cbTableName, 
						(UCHAR far *)szTableTypes,	// szTablesTypes, 
						22);				//cbTableType

	if (rc == SQL_SUCCESS || SQL_SUCCESS_WITH_INFO) 
	{
   	// Bind columns in result set to storage locations.
		SQLBindCol(hstmt, 1, SQL_C_CHAR, szQualifier, STR_LEN,&cbQualifier);
		SQLBindCol(hstmt, 2, SQL_C_CHAR, szOwner, STR_LEN, &cbOwner);
		SQLBindCol(hstmt, 3, SQL_C_CHAR, szTableName, STR_LEN,&cbTableName);
		SQLBindCol(hstmt, 4, SQL_C_CHAR, szTypeName, STR_LEN, &cbTypeName); 
		SQLBindCol(hstmt, 5, SQL_C_SHORT, &DataType, 0, &cbDataType);
		SQLBindCol(hstmt, 6, SQL_C_CHAR, szTypeName, STR_LEN, &cbTypeName);
		SQLBindCol(hstmt, 7, SQL_C_LONG, &Precision, 0, &cbPrecision);
		SQLBindCol(hstmt, 8, SQL_C_LONG, &Length, 0, &cbLength);
		SQLBindCol(hstmt, 9, SQL_C_SHORT, &Scale, 0, &cbScale);

		SQLBindCol(hstmt, 10, SQL_C_SHORT, &Radix, 0, &cbRadix);
		SQLBindCol(hstmt, 11, SQL_C_SHORT, &Nullable, 0, &cbNullable);
		SQLBindCol(hstmt, 12, SQL_C_CHAR, szRemarks, REM_LEN, &cbRemarks);
      		
		while(TRUE) 
		{
			rc = SQLFetch(hstmt);
			if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
			{
	        	// Add entry to listbox...
     	   	szEntry = "";
         	if(lstrlen((LPSTR)szOwner) > 0) 
        		{
        			szEntry = (LPSTR)szOwner;
        			szEntry += ".";
				}
				szEntry += (LPSTR)szTableName;
				pCB->AddString(szEntry);
			}
			else // (rc == SQL_ERROR)  
				break;
		} 
	}
	else			
	{
		ShowArrowCursor();
		MessageBox("Can't read table names.", "Database Error");
		SQLFreeStmt(hstmt, SQL_DROP);
		DB.Close();
		return FALSE;
	}           
	SQLFreeStmt(hstmt, SQL_DROP);
	DB.Close();
	return TRUE;
}                  

CString& DMainDlg::NoTableOwner(CString& szRawTableName)
{
   static CString s1;
   int p;

   // Remove table owner in-case it exists in table name...
   p = szRawTableName.Find('.');
   if (p > -1) 
      s1 = szRawTableName.Mid(p + 1);
   else
      s1 = szRawTableName;

	return s1;
}   

void DMainDlg::ParseFilePath (CString& szFullPath, CString& szPath, CString& szFile)
{
	int i;
   CString s1;
   
   i = szFullPath.GetLength();
   while(TRUE)
   {  
      s1 = szFullPath;
      if(szFullPath.Mid(i - 1, 1) != "\\") 
    	{
    		if (--i == 0) 
       		break;
		}
      else
    		break;
	}
	if(i > 0) 
	{
      szPath = szFullPath.Left(i - 1);
      szFile = szFullPath.Mid(i + 1);
   }
   else
   {
      szPath = szFullPath;
      szFile = szFullPath;
   }    
}   

void DMainDlg::SetConvRuleInEntry (int nThisLB, int n, CString& szNewRule, CString& szNewData)
{
   CString s;
   CString szNew;
   int p;
                                                             
	char szTemp[256];                                                             
                                                             
   SendDlgItemMessage(nThisLB, LB_GETTEXT, n, (LPARAM)(LPSTR)szTemp);      
   s = szTemp;     
         
   p = s.Find("[");

   if (p == -1) 
   	return;
   
   szNew = s.Mid(0, p + 1);
   szNew += szNewRule;

   if(szNewData.GetLength() > 0) 
   {
      szNew += ", ";
      szNew += szNewData;
   }

   szNew += "]";
      
   // Update item in list -- First insert, then delete old one.
   SendDlgItemMessage(nThisLB, WM_SETREDRAW, FALSE, 0L);
  	int nNew = (int)SendDlgItemMessage(nThisLB, LB_INSERTSTRING, n, (LPARAM)szNew.GetBuffer(256));
   if(nNew > -1)
	   SendDlgItemMessage(nThisLB, LB_DELETESTRING, (WPARAM)nNew + 1, 0L);
   SendDlgItemMessage(nThisLB, WM_SETREDRAW, TRUE, 0L);
}

void DMainDlg::ShowDBInfo (int nMyControl, SETTINGSINFO& Settings, int bShowSourceInfo)
{                               
	CWnd *pWnd = GetDlgItem(nMyControl);
	
	ASSERT(pWnd);
	if(!pWnd)
   	return;
   
   CString szText;
   
   if (bShowSourceInfo)  
   {
      // Show source info.
      if (Settings.SRCSQLSVR == TRUE)  
      {
         szText = "ODBC Server = ";
         szText += Settings.SRC_SERVR;
         szText += ", DB=";
         szText += Settings.SRC_DB;
         szText += ", USER=";
         szText += Settings.SRC_USERID;
      }   
      else
      {
         szText = Settings.SRC_CONN;
         szText += " in ";
         szText += Settings.SRC_PATH;
      }   
   }   
   else
   {
      // Show target info.
      if (Settings.DESTSQLSVR == TRUE) 
      {
         szText = "ODBC Server = ";
         szText += Settings.DEST_SERVR;
         szText += ", DB=";
         szText += Settings.DEST_DB;
         szText += ", USER=";
         szText += Settings.DESTUSERID;
      }
      else    
      {
         szText = Settings.DEST_CONN;
         szText += " in ";
         szText += Settings.DEST_PATH;
      }
	}
   pWnd->SetWindowText(szText);
   pWnd->UpdateWindow();
}   
   
void DMainDlg::UpdateTotal(void)
{                  
   int nBoundColCount = (int)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETCOUNT, 0, 0L);
   CString msg;   
      
   if(nBoundColCount == 0)
   	SayThis("(No bound columns.)");
   else
   {
		msg = ToStr(nBoundColCount);
		if(nBoundColCount == 1)
			msg += " bound column.";
		else		
			msg += " bound columns.";
   	SayThis(msg); 	
   }
}
                                             
void DMainDlg::AddBoundColumns (int nSourceLB, int nTargetLB)
{
   // Adds given bound columns in BoundColumnsList by index
   // Also, saves indices in ItemData() array.
   CString szEntry;
   CString szPad;
   int nSource;
   int nTarget;

	DWORD dwItemData;                   
                   
   CString szRule;
   CString szConvData;
                                   
   int nSrcLBCount = (int)SendDlgItemMessage(IDC_SOURCECOLUMNSLIST, LB_GETCOUNT, 0, 0L);                                
   int nTargLBCount = (int)SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_GETCOUNT, 0, 0L);                                
   int nBoundColsLBCount = (int)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETCOUNT, 0, 0L);                                
   
   if(nSourceLB < 0 || nSourceLB > nSrcLBCount)
    	return;
   if(nTargetLB < 0 || nTargetLB > nTargLBCount)
   	return;

   // Check that these fields haven't been bound yet.
   
   for(int i = 0; i < nBoundColsLBCount; i++)
   { 
   	dwItemData = SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETITEMDATA, i, 0L);                                
      nSource = (int)HIWORD(dwItemData);
      nTarget = (int)LOWORD(dwItemData);
      if(nTarget == nTargetLB)
      {
      	// Update previous target setting.
         AddConvTupleToList(IDC_BOUNDCOLUMNSLIST, IDC_SOURCECOLUMNSLIST, 
         						 IDC_TARGETCOLUMNSLIST, nSourceLB, nTargetLB, i);
         return;
      }
   }      

	// Otherwise, append this pair of columns to list...
   int nNewIndex = AddConvTupleToList(IDC_BOUNDCOLUMNSLIST, IDC_SOURCECOLUMNSLIST, 
     								 			  IDC_TARGETCOLUMNSLIST, nSourceLB, nTargetLB, -1);
}

void DMainDlg::ClearBoundColumns (void)
{
  	SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);                                
}               
                                    
void DMainDlg::MakeNewDesktop(void)
{
   // Changes settings to "new"...
   pMySettings->SETUPDESC = "Untitled";
   pMyDoc->SetDocumentName(pMySettings->SETUPDESC);
   
   SetDlgItemText(IDC_SOURCEDBINFO, (LPSTR)"(Not set)");
   SetDlgItemText(IDC_TARGETDBINFO, (LPSTR)"(Not set)");

   SendDlgItemMessage(IDC_SOURCETABLESLIST, CB_RESETCONTENT, 0, 0L);
   SendDlgItemMessage(IDC_TARGETTABLESLIST, CB_RESETCONTENT, 0, 0L);
   SendDlgItemMessage(IDC_SOURCECOLUMNSLIST, LB_RESETCONTENT, 0, 0L);
   SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);
   SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);
   
   SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_SETCURSEL, -1, 0L);
   SetDlgItemText(IDC_CONVERSIONDATA, (LPSTR)"");
   SetDlgItemText(IDC_STATUSMSG, (LPSTR)"(No bound columns.)");
}                                    

void DMainDlg::SayThis(CString& msg)
{     
	SendDlgItemMessage(IDC_STATUSMSG, WM_SETTEXT, 0, (LPARAM)(LPSTR)msg.GetBuffer(256));
}   
                        
void DMainDlg::SayThis(LPSTR lpszMsg) 
{ 
	CString temp; temp = lpszMsg; SayThis(temp); 
}               
                        
BOOL DMainDlg::LoadSettingsInfo (SETTINGSINFO& MySettings, CString& szFilter)
{ 
   CDatabase DB;
      
   int bDBOpened;
   int bTableOpened;
	int rc;
   CString szSQL;
   CString msg;
   
   bDBOpened = FALSE;
   bTableOpened = FALSE;

   ShowWaitCursor();

	CString szConnect = "ODBC;DSN=FoxPro Files;DBQ=";
	szConnect += pMyDoc->szSettingsPath; 
	szConnect += "\\SETTINGS.DBF";
	
	rc = OpenDatabase(DB, szConnect, FALSE);
	if(!rc)         
	{                    
		ShowArrowCursor();
	   msg = "Can't open SETTINGS.DBF in ";
	   msg += pMyDoc->szSettingsPath;         
	   msg += ". ";
	   msg += szNoFoxProHelp;
	   MessageBox(msg, "Can't Load Settings", MB_ICONEXCLAMATION);
	  	return FALSE;
   }
	TRY
	{   
		DSettingsRecordset snSettings(&DB);      
                                            
		szFilter = "SETUPID=";
		szFilter += ToStr(pMyDoc->nGlobalSetUpId);
		snSettings.m_strFilter = szFilter;		                                            
      
      szSQL = "SELECT * FROM SETTINGS";
      
      snSettings.Open(CRecordset::snapshot, szSQL);
	
		snSettings.MoveFirst();
   	if (snSettings.IsEOF())
   	{
      	ShowArrowCursor();
      	msg = "Settings not found in SETTINGS.DBF in ";
      	msg += pMyDoc->szSettingsPath;
      	msg += ".";
      	MessageBox(msg, "Can't Load Settings", MB_ICONEXCLAMATION);
      	
      	snSettings.Close();
      	DB.Close();
      	return FALSE;
      }	
   
   	// Otherwise load our settings...
   	MySettings.SETUPID = (int)snSettings.m_SETUPID;
   	MySettings.SETUPDESC = snSettings.m_SETUPDESC;
   	MySettings.SRC_CONN = snSettings.m_SRC_CONN;
   	MySettings.SRC_PATH = snSettings.m_SRC_PATH;
   	MySettings.SRCSQLSVR = snSettings.m_SRCSQLSVR;
   	MySettings.SRC_SERVR = snSettings.m_SRC_SERVR;
   	MySettings.SRC_DB = snSettings.m_SRC_DB;
   	MySettings.SRC_USERID = snSettings.m_SRC_USERID;
   	MySettings.SRC_PWD = snSettings.m_SRC_PWD;
   	MySettings.SRC_TABLE = snSettings.m_SRC_TABLE;
   	MySettings.DEST_CONN = snSettings.m_DEST_CONN;
   	MySettings.DEST_PATH = snSettings.m_DEST_PATH;
   	MySettings.DESTSQLSVR = snSettings.m_DESTSQLSVR;
   	MySettings.DEST_SERVR = snSettings.m_DEST_SERVR;
  		MySettings.DEST_DB = snSettings.m_DEST_DB;
   	MySettings.DESTUSERID = snSettings.m_DESTUSERID;
   	MySettings.DEST_PWD = snSettings.m_DEST_PWD;
   	MySettings.DEST_TABLE = snSettings.m_DEST_TABLE;
   	MySettings.SRC_SQL = snSettings.m_SRC_SQL;

   	snSettings.Close();
   	DB.Close();

   	ShowArrowCursor();
   	return TRUE;
	}
	CATCH(CDBException, e)
	{                    
		ShowArrowCursor();
	   msg = "Can't open SETTINGS.DBF in ";
	   msg += pMyDoc->szSettingsPath;         
	   msg += ". ";
	   msg += szNoFoxProHelp;
	   MessageBox(msg, "Can't Load Settings", MB_ICONEXCLAMATION);
	  	DB.Close();
	  	return FALSE;
 	}
   END_CATCH                    
   return FALSE; // Kill error.
}
         
         
BOOL DMainDlg::LoadXlatFldsRecs (int nThisBoundColsList, int nSourceList, int nTargetList, 
                						CString& szFilter, int nStatus)
{
   CDatabase DB;
   
   CString szSQL;

   int nSrcIndex;
   int nDestIndex;
   int nCount;

   int n;
   int rc;
      
   CString msg;   
      
   XLATFLDS ThisRec;

   ShowWaitCursor();

   SendDlgItemMessage(nThisBoundColsList, LB_RESETCONTENT, 0, 0L);
       
	CString szConnect = "ODBC;DSN=FoxPro Files;DBQ=";
	szConnect += pMyDoc->szSettingsPath; 
	szConnect += "\\SETTINGS.DBF";
       
   rc = OpenDatabase(DB, szConnect, FALSE);
   if(!rc)
	{   
   	ShowArrowCursor();
      msg = "Can't open XLATFLDS.DBF in ";
	   msg += pMyDoc->szSettingsPath;         
	   msg += ". ";
	   msg += szNoFoxProHelp;
	   MessageBox(msg, "Can't Load Settings", MB_ICONEXCLAMATION);
      return FALSE;
   }   

	TRY
	{   
   	DXlatFldsRecordset dsXlatFlds(&DB);
   
   	szSQL = "SELECT * FROM XLATFLDS"; 
      dsXlatFlds.m_strFilter = szFilter; 
      dsXlatFlds.m_strSort = "SETUPID, FIELDORDER";
      
      dsXlatFlds.Open(CRecordset::snapshot, szSQL);

	   dsXlatFlds.MoveFirst();

   	nCount = 0;

   	while(dsXlatFlds.IsEOF() == FALSE)
   	{  
   		if(dsXlatFlds.IsDeleted())
   		{
   			dsXlatFlds.MoveNext();
   			continue;
   		}	
   	
      	ThisRec.Clear();
      
	      ThisRec.SETUPID = (int)dsXlatFlds.m_SETUPID;
   	   ThisRec.FIELDORDER = (int)dsXlatFlds.m_FIELDORDER;
      	ThisRec.DEST_FIELD = dsXlatFlds.m_DEST_FIELD;
      	ThisRec.DEST_TYPE = dsXlatFlds.m_DEST_TYPE;
      	ThisRec.DEST_LEN = (int)dsXlatFlds.m_DEST_LEN;
      	ThisRec.SRC_FIELD = dsXlatFlds.m_SRC_FIELD;
      	ThisRec.SRC_TYPE = dsXlatFlds.m_SRC_TYPE;
	      ThisRec.SRC_LEN = (int)dsXlatFlds.m_SRC_LEN;
   	  	ThisRec.CONV_RULE = dsXlatFlds.m_CONV_RULE;
      	ThisRec.CONV_DATA = dsXlatFlds.m_CONV_DATA;
        
	      if (ThisRec.SRC_FIELD.GetLength() == 0) 
   	      nSrcIndex = 9999;
      	else           
			{
         	nSrcIndex = (int)SendDlgItemMessage(nSourceList, LB_FINDSTRING, 0, (LPARAM)(LPSTR)ThisRec.SRC_FIELD.GetBuffer(256));
         	if (nSrcIndex == -1)
         	{                     
         		msg = "Column ";
         		msg += ThisRec.SRC_FIELD;
         		msg += " not found in source table.";
         		MessageBox(msg, "Column not found", MB_ICONEXCLAMATION);   
			      dsXlatFlds.MoveNext();
					continue;
				}	
			}	
      	nDestIndex = (int)SendDlgItemMessage(nTargetList, LB_FINDSTRING, 0, (LPARAM)(LPSTR)ThisRec.DEST_FIELD.GetBuffer(256));
   	  	if (nDestIndex == -1)
	   	{
	      	msg = "Column ";
         	msg += ThisRec.DEST_FIELD;
         	msg += " not found in target table.";
         	MessageBox(msg,  "Column not found", MB_ICONEXCLAMATION);
		      dsXlatFlds.MoveNext();
           	continue;
         }	

	      // Otherwise, add in this tuple...
   	   n = AddConvTupleToList(nThisBoundColsList, nSourceList, nTargetList, nSrcIndex, nDestIndex, -1);
   	   SetConvRuleInEntry(nThisBoundColsList, n, ThisRec.CONV_RULE, ThisRec.CONV_DATA);

	      nCount++;
             
         msg = ToStr(nCount);
         msg += " record(s) loaded...";
   	   SetDlgItemText(nStatus, msg);

	      dsXlatFlds.MoveNext();
  		}

   	dsXlatFlds.Close();
   	DB.Close();
   	ShowArrowCursor();
   	return TRUE;
   }
   CATCH(CDBException, e)
	{      
      ShowArrowCursor();
      msg = "Can't access XLATFLDS.DBF in ";
      msg += pMyDoc->szSettingsPath;
		msg += ". ";
		msg += szNoFoxProHelp;
      MessageBox(msg.GetBuffer(256), "Can't Load Settings", MB_ICONEXCLAMATION);
      DB.Close();
		return FALSE;
   }
   END_CATCH
   return FALSE;  // Kill error.
}                        


BOOL DMainDlg::SaveSettingsInfo (int nThisBoundColsList, SETTINGSINFO& ThisRec, CString& szSettingsPath, int nStatus)
{
	CDatabase DB;
   
   CString szSQL;
 	CString szFilter;
   CString szEntry;
   CString msg;
   
   int i;
   int rc;
               
	int bErr = FALSE;               
               
	char szTemp[256];         
         
   XLATFLDS ThisColRec;

   ShowWaitCursor();
   
	CString szConnect = "ODBC;DSN=FoxPro Files;DBQ=";
	szConnect += szSettingsPath;
	szConnect += "\\SETTINGS.DBF";

   rc = OpenDatabase(DB, szConnect, FALSE);
	if(!rc)
	{
		ShowArrowCursor();
	   msg = "Can't open SETTINGS.DBF in ";
	   msg += szSettingsPath;         
	   msg += ". ";
	   msg += szNoFoxProHelp;
	   MessageBox(msg, "Can't Save Settings", MB_ICONEXCLAMATION);
	  	return FALSE;
	}   

	TRY
	{
		DSettingsRecordset dsSettings(&DB); 
				
   	szSQL = "SELECT * FROM SETTINGS WHERE SETUPID=";
   	szSQL += ToStr(ThisRec.SETUPID);
      
      dsSettings.Open(CRecordset::snapshot, szSQL);
   
	   dsSettings.MoveFirst();
	   if (dsSettings.IsEOF())
	   {
      	// Re-open with all records...
      	dsSettings.Close();
	      dsSettings.Open(CRecordset::snapshot, "SELECT * FROM SETTINGS");
         dsSettings.MoveFirst();
         dsSettings.AddNew();
      }   
	   else
   	   dsSettings.Edit();
      
   	// To here, fill-in our new or updated record...
   
   	// Otherwise load our settings...
   	dsSettings.m_SETUPID = ThisRec.SETUPID;
   	dsSettings.m_SETUPDESC = ThisRec.SETUPDESC;
   	dsSettings.m_SRC_CONN = ThisRec.SRC_CONN;
   	dsSettings.m_SRC_PATH = ThisRec.SRC_PATH;
   	dsSettings.m_SRCSQLSVR = ThisRec.SRCSQLSVR;
   	dsSettings.m_SRC_SERVR = ThisRec.SRC_SERVR;
   	dsSettings.m_SRC_DB = ThisRec.SRC_DB;
   	dsSettings.m_SRC_USERID = ThisRec.SRC_USERID;
   	dsSettings.m_SRC_PWD = ThisRec.SRC_PWD;
   	dsSettings.m_SRC_TABLE = ThisRec.SRC_TABLE;
   	dsSettings.m_DEST_CONN = ThisRec.DEST_CONN;
   	dsSettings.m_DEST_PATH = ThisRec.DEST_PATH;
   	dsSettings.m_DESTSQLSVR = ThisRec.DESTSQLSVR;
   	dsSettings.m_DEST_SERVR = ThisRec.DEST_SERVR;
   	dsSettings.m_DEST_DB = ThisRec.DEST_DB;
   	dsSettings.m_DESTUSERID = ThisRec.DESTUSERID;
   	dsSettings.m_DEST_PWD = ThisRec.DEST_PWD;
   	dsSettings.m_DEST_TABLE = ThisRec.DEST_TABLE;
   	dsSettings.m_SRC_SQL = ThisRec.SRC_SQL;

   	dsSettings.Update();
   
	   dsSettings.Close();
   
   	//Now save individual XLATFLDS records...                 
   	// 
    	int nThisBoundColsListCount = (int)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETCOUNT, 0, 0L); 

		// First, delete all records for this project.  
		// ***Note****!!! ODBC API here instead because CDatabase::ExecuteSQL() does not work for FoxPro ISAM DB.!!!
		SayThis("Initializing...");

   	szSQL = "SELECT * FROM XLATFLDS";
 		
 		szFilter = "SETUPID=";
		szFilter += ToStr(pMyDoc->MySettings.SETUPID);   	
      
      HSTMT hstmt;
      
		rc = SQLAllocStmt(DB.m_hdbc, &hstmt);
			              
		if(rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO)
		{
	   	if(DB.IsOpen())
				DB.Close();
			return FALSE;
		}	           
	
		ASSERT(hstmt);
		
		CString szDeleteSQL("DELETE FROM XLATFLDS WHERE ");
		szDeleteSQL +=	szFilter;                      
	   
		rc = SQLExecDirect(hstmt, (UCHAR far *)szDeleteSQL.GetBuffer(256), szDeleteSQL.GetLength());
		if(rc != SQL_SUCCESS)
		{
#ifdef _DEBUG		                                       
			UCHAR szSQLState[256];                              
			UCHAR szError[256];                              
			SDWORD dwErrCode;  
			SWORD wRetBytes;
			int nErr = SQLError(NULL, NULL, hstmt, szSQLState, &dwErrCode, szError, 256, &wRetBytes);
			MessageBox((LPSTR)szError, "SQL Error =");
#endif			
			msg = "Warning: Can't delete records from XLATFLDS.DBF.  (This is probably a limitation of the ODBC FoxPro driver.  Try saving to a new Set-Up I.D. using 'File | Save As' instead.";
			MessageBox(msg, "Can't Delete", MB_ICONEXCLAMATION);
			DB.Close();                    
			SayThis("(Couldn't save.)");
			return FALSE;
		}
		SQLFreeStmt(hstmt, SQL_DROP);
                     
   	DXlatFldsRecordset dsXlatFlds(&DB);

		dsXlatFlds.m_strFilter = szFilter;	                                                
	                                                
	   for(i = 0; i < nThisBoundColsListCount; i++)
		{
 		 	dsXlatFlds.Open(CRecordset::snapshot, "SELECT * FROM XLATFLDS");

      	msg = "Saving record #";
      	msg += ToStr(i + 1);
      	msg += " of ";
      	msg += ToStr(nThisBoundColsListCount);
      	msg += "...";
	
	      SayThis(msg);

	      ThisColRec.Clear();
      	                                      
      	SendDlgItemMessage(nThisBoundColsList, LB_GETTEXT, i, (LPARAM)(LPSTR)szTemp);
      	
      	szEntry = szTemp;
      	
      	rc = CopyLBEntryToXlatFlds(ThisColRec, szEntry, ThisRec.SETUPID, i);
                         
   		dsXlatFlds.MoveFirst();                      
	                                   
			rc = dsXlatFlds.IsDeleted();	                                   
			ASSERT(rc != TRUE);	                             
	                                   
      	dsXlatFlds.AddNew();

         dsXlatFlds.m_SETUPID = ThisColRec.SETUPID;
         dsXlatFlds.m_FIELDORDER = ThisColRec.FIELDORDER;
         dsXlatFlds.m_DEST_FIELD = ThisColRec.DEST_FIELD;
         dsXlatFlds.m_DEST_TYPE = ThisColRec.DEST_TYPE;
         dsXlatFlds.m_DEST_LEN = ThisColRec.DEST_LEN;
         dsXlatFlds.m_SRC_FIELD = ThisColRec.SRC_FIELD;
         dsXlatFlds.m_SRC_TYPE = ThisColRec.SRC_TYPE;
         dsXlatFlds.m_SRC_LEN = ThisColRec.SRC_LEN;
         dsXlatFlds.m_CONV_RULE = ThisColRec.CONV_RULE;
         dsXlatFlds.m_CONV_DATA = ThisColRec.CONV_DATA;
                                     
			TRY                                     
         {
         	dsXlatFlds.Update();
         }
         CATCH(CDBException, e)
         {               
         	msg = "Couldn't update XLATFLDS.DBF Record for SETUPID =";
         	msg += ToStr(ThisColRec.SETUPID);
         	msg += ", FIELDORDER=";
         	msg += ToStr(ThisColRec.FIELDORDER);
         	msg += ". (Error =";
         	msg += e->m_strError;
         	msg += ") Continue anyway?";
				rc = MessageBox(msg, "Can't Update XLATFLDS Table", MB_YESNOCANCEL | MB_ICONEXCLAMATION);				
				if(rc != IDYES)
				{
					DB.Close();	           
					SayThis("(Save canceled.)");
					return FALSE;	
				}
				else
					bErr = TRUE;	
         }	       
         END_CATCH
         dsXlatFlds.Close();
      }   
   
   	SetDlgItemText(nStatus, "");

   	dsXlatFlds.Close();
   	DB.Close();
   	
   	if(bErr)        
   	{
   		SayThis("(Not all records were saved.)");
			return FALSE;
		}	
		else	
			return TRUE;
	}
	CATCH(CDBException, e)
	{                  
		ShowArrowCursor();
	   msg = "Unable to save settings to SETTINGS.DBF and XLATFLDS.DBF in ";
	   msg += szSettingsPath;
	   msg += ". ";          
	   msg += "(Error = ";
	   msg += e->m_strError;
	   msg += ") ";
	   msg += szNoFoxProHelp;
	   MessageBox(msg, "Can't Save Settings", MB_ICONEXCLAMATION);
		DB.Close();	           
		SayThis("(Settings were not saved.)");
		return FALSE;	
	}
	END_CATCH	
	return FALSE;
}
                                    
/////////////////////////////////////////////////////////////////////////////
// DMainDlg message handlers

void DMainDlg::OnChangeSrcDBSettings()
{
	int rc;

   pMyDoc->DBSettings.DlgCaption = "Source DB Settings";
   pMyDoc->DBSettings.CONN = pMyDoc->MySettings.SRC_CONN;
   pMyDoc->DBSettings.PATH = pMyDoc->MySettings.SRC_PATH;
   pMyDoc->DBSettings.SQLSVR = pMyDoc->MySettings.SRCSQLSVR;
   pMyDoc->DBSettings.SERVR = pMyDoc->MySettings.SRC_SERVR;
   pMyDoc->DBSettings.DB = pMyDoc->MySettings.SRC_DB;
   pMyDoc->DBSettings.USERID = pMyDoc->MySettings.SRC_USERID;
   pMyDoc->DBSettings.PWD = pMyDoc->MySettings.SRC_PWD;
   pMyDoc->DBSettings.TABLE = pMyDoc->MySettings.SRC_TABLE;

	DBSettingsDlg MySettingsDlg;
	rc = MySettingsDlg.DoModal();      
   if(rc == IDOK)
   { 
      pMyDoc->MySettings.SRC_CONN = pMyDoc->DBSettings.CONN;
      pMyDoc->MySettings.SRC_PATH = pMyDoc->DBSettings.PATH;
      pMyDoc->MySettings.SRCSQLSVR = pMyDoc->DBSettings.SQLSVR;
      pMyDoc->MySettings.SRC_SERVR = pMyDoc->DBSettings.SERVR;
      pMyDoc->MySettings.SRC_DB = pMyDoc->DBSettings.DB;
      pMyDoc->MySettings.SRC_USERID = pMyDoc->DBSettings.USERID;
      pMyDoc->MySettings.SRC_PWD = pMyDoc->DBSettings.PWD;
      pMyDoc->MySettings.SRC_TABLE = pMyDoc->DBSettings.TABLE;
      if(pMyDoc->MySettings.SRC_CONN == "ODBC") 
      {
         pMyDoc->szGlobalSourceConnect = "ODBC;DSN=";
         pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_SERVR;
         pMyDoc->szGlobalSourceConnect += ";UID=";
         pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_USERID;
         pMyDoc->szGlobalSourceConnect += ";PWD=";
         pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_PWD;
         pMyDoc->szGlobalSourceConnect += ";DBQ=";
         pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_DB;
      }
      else                                                  
      {
         pMyDoc->szGlobalSourceConnect = "ODBC;DSN=";
         pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_CONN;
         pMyDoc->szGlobalSourceConnect += ";DBQ=";
			pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_PATH;
      }
      ShowDBInfo(IDC_SOURCEDBINFO, pMyDoc->MySettings, TRUE);
                         
		rc = FillCBWithTableNames(IDC_SOURCETABLESLIST, pMyDoc->szGlobalSourceConnect);
      
      pMyDoc->SetupChanged();
   }
}

void DMainDlg::OnChangeTargetDBSettings()
{     
	int rc;

   pMyDoc->DBSettings.DlgCaption = "Target DB Settings";
   pMyDoc->DBSettings.CONN = pMyDoc->MySettings.DEST_CONN;
   pMyDoc->DBSettings.PATH = pMyDoc->MySettings.DEST_PATH;
   pMyDoc->DBSettings.SQLSVR = pMyDoc->MySettings.DESTSQLSVR;
   pMyDoc->DBSettings.SERVR = pMyDoc->MySettings.DEST_SERVR;
   pMyDoc->DBSettings.DB = pMyDoc->MySettings.DEST_DB;
   pMyDoc->DBSettings.USERID = pMyDoc->MySettings.DESTUSERID;
   pMyDoc->DBSettings.PWD = pMyDoc->MySettings.DEST_PWD;
   pMyDoc->DBSettings.TABLE = pMyDoc->MySettings.DEST_TABLE;

	DBSettingsDlg MySettingsDlg;
	rc = MySettingsDlg.DoModal();       
   if (rc == IDOK)
   { 
      pMyDoc->MySettings.DEST_CONN = pMyDoc->DBSettings.CONN;
      pMyDoc->MySettings.DEST_PATH = pMyDoc->DBSettings.PATH;
      pMyDoc->MySettings.DESTSQLSVR = pMyDoc->DBSettings.SQLSVR;
      pMyDoc->MySettings.DEST_SERVR = pMyDoc->DBSettings.SERVR;
      pMyDoc->MySettings.DEST_DB = pMyDoc->DBSettings.DB;
      pMyDoc->MySettings.DESTUSERID = pMyDoc->DBSettings.USERID;
      pMyDoc->MySettings.DEST_PWD = pMyDoc->DBSettings.PWD;
      pMyDoc->MySettings.DEST_TABLE = pMyDoc->DBSettings.TABLE;
                                
      if (pMyDoc->MySettings.DEST_CONN == "ODBC") 
      {
         pMyDoc->szGlobalTargetConnect = "ODBC;DSN=";
         pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_SERVR;
         pMyDoc->szGlobalTargetConnect += ";UID=";
         pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DESTUSERID;
         pMyDoc->szGlobalTargetConnect += ";PWD=";
         pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_PWD;
         pMyDoc->szGlobalTargetConnect += ";DBQ=";
         pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_DB;
      }
      else                                                  
      {
         pMyDoc->szGlobalTargetConnect = "ODBC;DSN=";
         pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_CONN;
         pMyDoc->szGlobalTargetConnect += ";DBQ=";
			pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_PATH;
      }
      ShowDBInfo(IDC_TARGETDBINFO, pMyDoc->MySettings, FALSE);

		rc = FillCBWithTableNames(IDC_TARGETTABLESLIST, pMyDoc->szGlobalTargetConnect);
      
      pMyDoc->SetupChanged();
   }   
}

void DMainDlg::OnFileOpen()
{  
	int rc;
	CString msg;
	
	OpenSetUpDlg MyOpenDlg;

   CString szFilter;

   // Check for dirty file...
   if (pMyDoc->IsDirty()) 
   {
   	msg = pMyDoc->MySettings.SETUPDESC;
   	msg += " has changed. Do you want to save the changes?";
      rc = MessageBox(msg, "DB Diplomat", MB_YESNOCANCEL | MB_ICONEXCLAMATION );
      if (rc == IDCANCEL) 
         return;  // Cancel
      else if (rc == IDYES) 
    	{
         // Save first!
         OnFileSave();
         if (rcGlobal == -5) 
            return;
      }
	}

   // To here, open it...
   rc = MyOpenDlg.DoModal();	
   if (rc == IDOK) 
   {                
      szFilter = "SETUPID=";
      szFilter = ToStr(pMyDoc->nGlobalSetUpId);

      rc = LoadSettingsInfo(pMyDoc->MySettings, szFilter);
      if (rc) 
		{
         // Now stuff values from settings to desktop.
         ShowWaitCursor();
         SayThis("Loading Set-Up...");
         pMyDoc->szGlobalSourcePath = "";
         if (pMyDoc->MySettings.SRC_CONN == "ODBC") 
         {
            pMyDoc->szGlobalSourceConnect = "ODBC;DSN=";
            pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_SERVR;
            pMyDoc->szGlobalSourceConnect += ";UID=";
            pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_USERID;
            pMyDoc->szGlobalSourceConnect += ";PWD=";
            pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_PWD;
            pMyDoc->szGlobalSourceConnect += ";DBQ=";
            pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_DB;
         }
         else                                                  
         {
            pMyDoc->szGlobalSourceConnect = "ODBC;DSN=";
            pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_CONN;
            pMyDoc->szGlobalSourceConnect += ";DBQ=";
				pMyDoc->szGlobalSourceConnect += pMyDoc->MySettings.SRC_PATH;
	      }
         
         ShowDBInfo(IDC_SOURCEDBINFO, pMyDoc->MySettings, TRUE);
      
         rc = FillCBWithTableNames(IDC_SOURCETABLESLIST, pMyDoc->szGlobalSourceConnect);
         
         SendDlgItemMessage(IDC_SOURCETABLESLIST, LB_SELECTSTRING, -1, (LPARAM)(LPSTR)pMyDoc->MySettings.SRC_TABLE.GetBuffer(256));
			OnSourceTablesListClick();               
               
         if (pMyDoc->MySettings.DEST_CONN == "ODBC") 
         {
            pMyDoc->szGlobalTargetConnect = "ODBC;DSN=";
            pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_SERVR;
            pMyDoc->szGlobalTargetConnect += ";UID=";
            pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DESTUSERID;
            pMyDoc->szGlobalTargetConnect += ";PWD=";
            pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_PWD;
            pMyDoc->szGlobalTargetConnect += ";DBQ=";
            pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_DB;
         }
         else                                                  
         {
            pMyDoc->szGlobalTargetConnect = "ODBC;DSN=";
            pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_CONN;
            pMyDoc->szGlobalTargetConnect += ";DBQ=";
				pMyDoc->szGlobalTargetConnect += pMyDoc->MySettings.DEST_PATH;
	      }
                           
         ShowDBInfo(IDC_TARGETDBINFO, pMyDoc->MySettings, FALSE);
      
         rc = FillCBWithTableNames(IDC_TARGETTABLESLIST, pMyDoc->szGlobalTargetConnect);

         SendDlgItemMessage(IDC_TARGETTABLESLIST, LB_SELECTSTRING, -1, (LPARAM)(LPSTR)pMyDoc->MySettings.DEST_TABLE.GetBuffer(256));
			OnTargetTablesListClick();               
         
         pMyDoc->SetupIsNotNew();
         pMyDoc->SetupIsClean();

         SayThis("");
         ShowArrowCursor();

         rc = LoadXlatFldsRecs(IDC_BOUNDCOLUMNSLIST, IDC_SOURCECOLUMNSLIST, 
         							 IDC_TARGETCOLUMNSLIST, szFilter, IDC_STATUSMSG);
      }
      pMyDoc->SetDocumentName(pMyDoc->MySettings.SETUPDESC);
   }
}

void DMainDlg::OnFileSaveAs()
{                                             
	int rc;
	
	rcGlobal = TRUE;
	SaveSetUpDlg MySaveDlg;
	rc = MySaveDlg.DoModal();	 
   if (rc == IDOK) 
   {                     
       rc = SaveSettingsInfo(IDC_BOUNDCOLUMNSLIST, pMyDoc->MySettings, pMyDoc->szSettingsPath, IDC_STATUSMSG);
      if (rc)                    
      {
         pMyDoc->SetupIsNotNew();
         pMyDoc->SetupIsClean(); 
         pMyDoc->SetDocumentName(pMyDoc->MySettings.SETUPDESC);
      }   
   }
   else 
   	rcGlobal = -5;  // Let caller know 'Save As' dialog box was cancelled by user.
}

void DMainDlg::OnEditCustomSrcSQL()
{
	EditSrcSQLDlg MyEditSrcSQLDlg;
	MyEditSrcSQLDlg.DoModal();	
}

void DMainDlg::OnFileSave()
{
	int rc;       
	
	rcGlobal = TRUE;
	
   rc = pMyDoc->IsNew();
   if (rc)   
   {          
   	// New 'Untitled' files are handled by 'File Save As...'
   	OnFileSaveAs();
  		return;
   }	

   rc = SaveSettingsInfo(IDC_BOUNDCOLUMNSLIST, pMyDoc->MySettings, pMyDoc->szSettingsPath, IDC_STATUSMSG);
   if (rc) 
      pMyDoc->SetupIsClean();
   else
   	rcGlobal = -5;  // Let caller know we failed.    
}

void DMainDlg::OnFileNew()
{   
	int rc;           
	CString msg;                             
	                     
	if(!pMyDoc)	                     
		pMyDoc = (DBDiplomatDoc *)GetDocument();
	ASSERT(pMyDoc);

	if(!pMyDoc)
		return;	            
   
   if(!pMySettings)
		pMySettings=&pMyDoc->MySettings;	                           
	                           
   if (pMyDoc->IsDirty())
   {           
   	msg = pMySettings->SETUPDESC;
   	msg += " has changed.  Do you want to save the changes?";
      rc = MessageBox(msg, "DB Diplomat", MB_YESNOCANCEL | MB_ICONEXCLAMATION);
      if (rc == IDCANCEL)
         return;  // Cancel
      else if (rc == IDYES)
      {
         //  Save first!
         OnFileSave();
         if (rcGlobal == -5)
            return;
      }
   }
   
   pMySettings->Clear();
   
   MakeNewDesktop();
   pMyDoc->MarkAsNewSetup();
}

void DMainDlg::OnAddAllTargetCols()
{     
	int rc;
   int i;
      
   int nNewIndex;   
      
	DWORD dwItemData;      
                          
	CString msg;                          
                                     
 	int nTargCount = (int)SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_GETCOUNT, 0, 0L);                                   
   if (nTargCount == 0) 
      return;
               
   msg = "Create blank list of ";
   msg += ToStr(nTargCount);
   msg += " columns?";          
   rc = MessageBox(msg, "Add Target Columns", MB_YESNOCANCEL | MB_ICONQUESTION);
   if (rc != IDYES) 
      return;

 	SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);

   for(i = 0; i < nTargCount; i++)
   {
		// Otherwise, append this pair of columns to list...
   	nNewIndex = AddConvTupleToList(IDC_BOUNDCOLUMNSLIST, IDC_SOURCECOLUMNSLIST, 
     								 			     IDC_TARGETCOLUMNSLIST, 9999, i, -1);
                                              
   	// Store indices along with text item in ItemData() array.
   	dwItemData = MAKELONG(i, 9999);
  		SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_SETITEMDATA, nNewIndex, (LPARAM)dwItemData);                                
   }

   OnBoundColumnsListClick();
         
	UpdateTotal();         
         
   pMyDoc->SetupChanged();
}

void DMainDlg::OnBind()
{  
	int nSource;
   int nTarget;

   nSource = (int)SendDlgItemMessage(IDC_SOURCECOLUMNSLIST, LB_GETCURSEL, 0, 0L);
   nTarget = (int)SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_GETCURSEL, 0, 0L); 
   AddBoundColumns(nSource, nTarget);

   OnBoundColumnsListClick();

	UpdateTotal();         

   pMyDoc->SetupChanged();
}

void DMainDlg::OnBindAll()
{
	int i;
   
   SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);

   CString szEntry;

   ShowWaitCursor();
                      
   int nSrcColLBCount = (int)SendDlgItemMessage(IDC_SOURCECOLUMNSLIST, LB_GETCOUNT, 0, 0L);                   
   int nTargColLBCount = (int)SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_GETCOUNT, 0, 0L);                   
                      
   for(i = 0; i <  nSrcColLBCount; i++)
   {
      if(i > nTargColLBCount - 1) 
         break;
	   AddBoundColumns(i, i);
   }
   
   OnBoundColumnsListClick();

   pMyDoc->SetupChanged();

	UpdateTotal();         

   ShowArrowCursor();
}

void DMainDlg::OnBindAllForward()
{
   int i;
   int j;
   int nStartSource;
   int nStartTarget;
   
   nStartSource = (int)SendDlgItemMessage(IDC_SOURCECOLUMNSLIST, LB_GETCURSEL, 0, 0L);
   nStartTarget = (int)SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_GETCURSEL, 0, 0L);

   int nSrcColLBCount = (int)SendDlgItemMessage(IDC_SOURCECOLUMNSLIST, LB_GETCOUNT, 0, 0L);                   
   int nTargColLBCount = (int)SendDlgItemMessage(IDC_TARGETCOLUMNSLIST, LB_GETCOUNT, 0, 0L);                   
   
   if(nStartSource == -1 || nStartTarget == -1)
   { 
      MessageBox("Select a column both source and target first!", "Columns Not Selected", MB_ICONEXCLAMATION);
      return;
   }

   ShowWaitCursor();

   j = nStartTarget;
   for(i = nStartSource; i < nSrcColLBCount && j < nTargColLBCount; i++, j++)
   {               
   	// Bind columns forward--look out for end-of-list.
      AddBoundColumns(i, j);
   }   

   OnBoundColumnsListClick();

   pMyDoc->SetupChanged();

	UpdateTotal();         

   ShowArrowCursor();
}

void DMainDlg::OnChangeSetUpPath()
{                                    
	CString szDirOnly;
	CString szFileOnly;
	CString szFullPath;                     
                  
	CFileDialog BrowseDlg(TRUE, "dbf", "settings.dbf", OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST,
   							"FoxPro Files (*.dbf) | (*.dbf) ||");
      
	int rc = BrowseDlg.DoModal();
	if(rc)
	{
		// On success convert paths to upper-case
		szFullPath = BrowseDlg.GetPathName();	            

      ParseFilePath (szFullPath, szDirOnly, szFileOnly);                                  
                              
		szDirOnly.MakeUpper();                              
                                  
		pMyDoc->szSettingsPath = szDirOnly;
	}
}
                                          
void DMainDlg::OnEditSetupDesc()
{
	int rc;

	EditSetUpDescDlg MyEditSetUpDescDlg;
	rc = MyEditSetUpDescDlg.DoModal();	
   if (rc)
   {                          
      pMyDoc->SetupChanged();
      pMyDoc->SetDocumentName(pMyDoc->MySettings.SETUPDESC);
   }
}

void DMainDlg::OnToggleEmptyTargetOption()
{                                                                       
	// Toggle 'delete target first' option...
	pMyDoc->bDeleteDataFirst = pMyDoc->bDeleteDataFirst ? FALSE : TRUE;	
                             
	// Because we DMainDlg is controlled by CFormView, get our parent's menu.                                   
	CWnd *pMyParent = GetParent();                                  
	ASSERT(pMyParent);
   CMenu *pMyMenu = pMyParent->GetMenu();
   ASSERT(pMyMenu);
   if(!pMyMenu)
   	return;
   	                                                   
	int nCheckState = pMyDoc->bDeleteDataFirst ? MF_CHECKED : MF_UNCHECKED;    	                                                   
   	                                                   
	pMyMenu->CheckMenuItem(IDM_EMPTYTARGET, nCheckState);
}

void DMainDlg::OnTransferData()
{  
	CString msg;              
   long rc = DoDataTransfer(pMyDoc->MySettings, pMyDoc->szSettingsPath, pMyDoc->bDeleteDataFirst, IDC_BOUNDCOLUMNSLIST, IDC_STATUSMSG);
	      
	if(rc == 0)
	   SayThis("(No records transferred.)");
	else if(rc == 1)
	   SayThis("1 record successfully transferred.");
	else
	{
		CString msg;   
	   char szTemp[40];
		msg = ltoa(rc, szTemp, 10);
		msg += " records successfully transferred.";
		SayThis(msg);
	}	   
}

void DMainDlg::OnUnbind()
{
   int n;

   n = (int)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETCURSEL, 0, 0L);
   
   if(n > -1)                                                     
   	SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_DELETESTRING, n, 0L);
   OnBoundColumnsListClick();

	UpdateTotal();         

   pMyDoc->SetupChanged();
}

void DMainDlg::OnUnbindAll()
{                                                                 
	SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);
   OnBoundColumnsListClick();

	UpdateTotal();         

   pMyDoc->SetupChanged();
}

void DMainDlg::OnBoundColumnsListClick()
{     
   int i;
   CString s;
   CString szRule;
   CString szData;
   int rc;
   
   char szTemp[256];
   
   nEditIndex = -1;
   i = (int)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETCURSEL, 0, 0L);
   if (i > -1) 
   {                                                                    
      SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETTEXT, i, (LPARAM)(LPSTR)szTemp);
      s = szTemp;
      GetConvRuleFromEntry(s, szRule, szData);
      rc = (int)SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_FINDSTRING, -1, (LPARAM)(LPSTR)szRule.GetBuffer(256));
      if (rc > -1)                      
      {               
      	SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_SETCURSEL, rc, 0L);
         if (rc == 1 || rc == 3 || rc == 4) 
         {                                 
         	GetDlgItem(IDC_CONVERSIONDATA)->EnableWindow(TRUE);
         	SetDlgItemText(IDC_CONVERSIONDATA, szData);
         	bConversionDataEnabled = TRUE;
         }
         else
         {
         	GetDlgItem(IDC_CONVERSIONDATA)->EnableWindow(FALSE);
         	SetDlgItemText(IDC_CONVERSIONDATA, "");
         	bConversionDataEnabled = FALSE;
         }
         nEditIndex = i;
      }   
   }
   else
   {
      SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_SETCURSEL, -1, 0L);
      SetDlgItemText(IDC_CONVERSIONDATA, "");
     	bConversionDataEnabled = FALSE;
   }   
}

void DMainDlg::OnAppExit()
{
	int rc;          
	CString msg;
   if (pMyDoc->IsDirty()) 
	{   
		msg = pMyDoc->MySettings.SETUPDESC;
		msg += " has changed. Do you want to save the changes?";
      rc = MessageBox(msg, "DB Diplomat", MB_YESNOCANCEL | MB_ICONEXCLAMATION);
      if (rc == IDCANCEL) 
      	return;
      else if (rc == IDYES) 
		{
         // Save first!
         OnFileSave();
         if (rcGlobal == -5) 
         	return;
      }   	
	}
	DestroyWindow();              
	DestroyWindow(); // Call twice to assure exit.  (One call sometimes leaves the program running.)             
}

void DMainDlg::OnConversionDataChange()
{
	CString szRule;
   CString szData;
      
   char szTemp[256];   	
      
   if (bCanEditData == FALSE) 
		return;

   if (nEditIndex > -1) 
   {
      int n = (int)SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_GETCURSEL, 0, 0L);
    	if(n == -1)
    		return;  // Unexpected...
  		GetDlgItemText(IDC_CONVERSIONRULELIST, (LPSTR)szTemp, 256);                                              
      szRule = szTemp;                           
      if (bConversionDataEnabled == FALSE) 
         szData = "";
      else
      {
      	GetDlgItemText(IDC_CONVERSIONDATA, szTemp, 256);
         szData = szTemp;
      }   
      SetConvRuleInEntry(IDC_BOUNDCOLUMNSLIST, nEditIndex, szRule, szData);
   }
   pMyDoc->SetupChanged();
}

void DMainDlg::OnConversionDataSetFocus()
{
   bCanEditData = TRUE;
}

void DMainDlg::OnConversionDataKillFocus()
{
   bCanEditData = FALSE;
}

void DMainDlg::OnConversionRuleListClick()
{     
   CString szRule;
   CString szData;
   int n;
    
   char szTemp[256]; 
	DWORD dwBoundColData;    
	
   if (bCanEditRule == FALSE) 
      return;

   n = (int)SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_GETCURSEL, 0, 0L);

   if (n == 1 || n == 3 || n == 4) 
   {
     	GetDlgItem(IDC_CONVERSIONDATA)->EnableWindow(TRUE);
     	SetDlgItemText(IDC_CONVERSIONDATA, szData);
     	bConversionDataEnabled = TRUE;
   }
   else
   {
     	GetDlgItem(IDC_CONVERSIONDATA)->EnableWindow(FALSE);
     	SetDlgItemText(IDC_CONVERSIONDATA, "");
     	bConversionDataEnabled = FALSE;
   }

   if (nEditIndex > -1) 
   {                             
    	int n = (int)SendDlgItemMessage(IDC_CONVERSIONRULELIST, CB_GETCURSEL, 0, 0L);	
      if(n == -1)
      	return;  // Unexpected...
    	GetDlgItemText(IDC_CONVERSIONRULELIST, szTemp, 256);	
      szRule = szTemp;

      if (szRule == "BlankValue" || szRule == "StuffValue") 
      {                                                                                                               
      	dwBoundColData = (DWORD)SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_GETITEMDATA, nEditIndex, 0L);
         AddConvTupleToList(IDC_BOUNDCOLUMNSLIST, IDC_SOURCECOLUMNSLIST, IDC_TARGETCOLUMNSLIST, 9999, (int)LOWORD(dwBoundColData), nEditIndex);
      }

      if (bConversionDataEnabled == FALSE) 
         szData = "";
      else
      {        
      	GetDlgItemText(IDC_CONVERSIONDATA, (LPSTR)szTemp, 256);                           
         szData = szTemp;
      }                  
      
      SetConvRuleInEntry(IDC_BOUNDCOLUMNSLIST, nEditIndex, szRule, szData);
   }
   pMyDoc->SetupChanged();
}

void DMainDlg::OnConversionRuleListSetFocus()
{
  	bCanEditRule = TRUE;
}

void DMainDlg::OnConversionRuleListKillFocus()
{
	bCanEditRule = FALSE;
}

void DMainDlg::OnSourceTablesListClick()
{
	CString szTable;
	int rc;
   char szTemp[256];
    
   SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);
             
   GetDlgItemText(IDC_SOURCETABLESLIST, (LPSTR)szTemp, 256);

   szTable = szTemp;
                                                                                 
   rc = LoadTableColumns(IDC_SOURCECOLUMNSLIST, pMyDoc->szGlobalSourceConnect, szTable);
   
   pMyDoc->MySettings.SRC_TABLE = szTable;
   pMyDoc->SetupChanged();
}

void DMainDlg::OnTargetTablesListClick()
{
   CString szTable;
   int rc;                                
   char szTemp[256];
   
   SendDlgItemMessage(IDC_BOUNDCOLUMNSLIST, LB_RESETCONTENT, 0, 0L);

   GetDlgItemText(IDC_TARGETTABLESLIST, (LPSTR)szTemp, 256);

   szTable = szTemp;
   
   rc = LoadTableColumns(IDC_TARGETCOLUMNSLIST, pMyDoc->szGlobalTargetConnect, szTable);
   
   pMyDoc->MySettings.DEST_TABLE = szTable;
   pMyDoc->SetupChanged();
}

void DMainDlg::OnChangeSourceBtnClick()
{
	OnChangeSrcDBSettings();
}

void DMainDlg::OnChangeTargetDBBtnClick()
{
	OnChangeTargetDBSettings();
}

void DMainDlg::OnBindBtnClick()
{
	OnBind();
}

void DMainDlg::OnUnbindBtnClick()
{
	OnUnbind();
}

void DMainDlg::OnUnbindAllBtnClick()
{
   OnUnbindAll();
}

void DMainDlg::OnBindAllFwdBtnClick()
{
	OnBindAllForward();
}

void DMainDlg::OnBindAllBtnClick()
{
   OnBindAll();
}

void DMainDlg::OnAddAllTargColsBtnClick()
{
	OnAddAllTargetCols();
}

void DMainDlg::OnTransferDataBtnClick()
{
	OnTransferData();	
}
   
   
void DMainDlg::OnInitialUpdate()
{
	// (Get our document for our dialogs, which might need to access document data and are
	//  not inherited from CView...)
                                              
	pMyDoc = (DBDiplomatDoc *)GetDocument();
	ASSERT(pMyDoc);

	if(!pMyDoc)
		return;	                      
		            
	// Let other dialogs access our 'global'--variables in DBDiplomatDoc.	            
	SetDoc(pMyDoc);	
		
	pMySettings=&pMyDoc->MySettings;	                           
                     
	// Get current working directory, set this with Program Manager / Win95 short-cut.                                 
	char szTemp[256];                  
	int nLastChar;
	LPSTR lpszDir = _getcwd((LPSTR)szTemp, 256);
	if(lpszDir)
	{
		// Check for root = '\\' terminated.
		nLastChar = lstrlen(szTemp) - 1;
		if(nLastChar > -1)
		{
			if(szTemp[nLastChar] == '\\')
				szTemp[nLastChar] = '\0';
		}
		pMyDoc->szSettingsPath = szTemp;	
	}	                                 
                     
   LoadConversionRules(IDC_CONVERSIONRULELIST);
   
   // Start out with 'New' Set-Up...
   OnFileNew();
   
   nEditIndex = -1;
   bCanEditRule = FALSE;
   bCanEditData = FALSE;
                        
	rcGlobal = FALSE;                        
}

