// dmaindlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// DMainDlg form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif
                             
#include "dbdipdoc.h"                             
#include "settypes.h"                           
                           
class DMainDlg : public CFormView
{
	DECLARE_DYNCREATE(DMainDlg)
protected:
	DMainDlg();			// protected constructor used by dynamic creation

// Form Data
public:
	//{{AFX_DATA(DMainDlg)
	enum { IDD = IDD_MAINDLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA
// Attributes
public:
	int nEditIndex;
	int bCanEditRule;
	int bCanEditData;      
	int bConversionDataEnabled;
		
	int rcGlobal;  

	SETTINGSINFO *pMySettings;        
	DBDiplomatDoc *pMyDoc;
      
// Operations
public:
	// Move dataf around our controls...
	int AddConvTupleToList(int nConvLB, int nSrcLB, int nTargLB, int nSourceLBIndex, int nTargetLBIndex, int nIndex);
   long DoDataTransfer (SETTINGSINFO& Settings, CString& szMySettingsPath, int bDelTargetFirst, 
                       int nBoundColsList, int nStatus);
	void GetConvRuleFromEntry (CString& szEntry, CString& szRule, CString& szData);
	CString& GetDataTypeAsStr(int nType, int nLen);
   CString& GuessConvertRule (int nDestType, int nDestLen, int nSrcType, int nSrcLen, CString& szConvData);
	int CopyLBEntryToXlatFlds(XLATFLDS& ThisRec, CString& szEntry, int nMySetUpId, int nOrder);
   void LoadConversionRules (int nThisLBID);
	int LoadTableColumns (int nLBID, CString& szConnect, CString& szTable);
	BOOL FillCBWithTableNames(int nCBID, CString& szConnect);
	CString& NoTableOwner (CString& szRawTableName);
	void ParseFilePath (CString& szFullPath, CString& szPath, CString& szFile);
   void SetConvRuleInEntry (int nThisLB, int n, CString& szNewRule, CString& szNewData);
	int DumpColumnLBToColumnArray(int nLBID, COLUMNINFO **pMyArray);
	int DumpBoundColsLBToBoundColsArray(int nLBID, BOUNDCOLUMNSINFO **pMyArray);
	void ShowDBInfo (int nCtrlId, SETTINGSINFO& Settings, int bShowSourceInfo);
	void UpdateTotal(void);	                                  
	                                  
	void AddBoundColumns (int nSourceLB, int nTargetLB);
	void ClearBoundColumns (void);
	void MakeNewDesktop(void);     
	void SayThis(CString& msg);
   void SayThis(LPSTR lpszMsg);                
                  
	void OnInitialUpdate();
	int GetNewSetUpId (CString& SettingsPath);
	BOOL LoadSettingsInfo (SETTINGSINFO& MySettings, CString& szFilter);
   BOOL LoadXlatFldsRecs (int nThisBoundsColsList, int nSourceList, int nTargetList, 
          					  	CString& szFilter, int nStatus);
   BOOL SaveSettingsInfo (int nThisBoundColsList, SETTINGSINFO& ThisRec, CString& szSettingsPath, int nStatus);
                      
// Implementation
protected:
	virtual ~DMainDlg();
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	// Generated message map functions
	//{{AFX_MSG(DMainDlg)
	afx_msg void OnChangeSrcDBSettings();
	afx_msg void OnChangeTargetDBSettings();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSaveAs();
	afx_msg void OnEditCustomSrcSQL();
	afx_msg void OnFileSave();
	afx_msg void OnFileNew();
	afx_msg void OnAddAllTargetCols();
	afx_msg void OnBind();
	afx_msg void OnBindAll();
	afx_msg void OnBindAllForward();
	afx_msg void OnChangeSetUpPath();
	afx_msg void OnEditSetupDesc();
	afx_msg void OnToggleEmptyTargetOption();
	afx_msg void OnTransferData();
	afx_msg void OnUnbind();
	afx_msg void OnUnbindAll();
	afx_msg void OnBoundColumnsListClick();
	afx_msg void OnAppExit();
	afx_msg void OnConversionDataChange();
	afx_msg void OnConversionDataSetFocus();
	afx_msg void OnConversionDataKillFocus();
	afx_msg void OnConversionRuleListClick();
	afx_msg void OnConversionRuleListSetFocus();
	afx_msg void OnConversionRuleListKillFocus();
	afx_msg void OnSourceTablesListClick();
	afx_msg void OnTargetTablesListClick();
	afx_msg void OnChangeSourceBtnClick();
	afx_msg void OnChangeTargetDBBtnClick();
	afx_msg void OnBindBtnClick();
	afx_msg void OnUnbindBtnClick();
	afx_msg void OnUnbindAllBtnClick();
	afx_msg void OnBindAllFwdBtnClick();
	afx_msg void OnBindAllBtnClick();
	afx_msg void OnAddAllTargColsBtnClick();
	afx_msg void OnTransferDataBtnClick();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
