// opnsetup.cpp : implementation file
//

#include "stdafx.h"
#include "dbdiplom.h"
#include "dbdipdoc.h"
#include "opnsetup.h"     
#include "setngrec.h"

#include "tools.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// OpenSetUpDlg dialog


OpenSetUpDlg::OpenSetUpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(OpenSetUpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(OpenSetUpDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void OpenSetUpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(OpenSetUpDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(OpenSetUpDlg, CDialog)
	//{{AFX_MSG_MAP(OpenSetUpDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// OpenSetUpDlg message handlers

BOOL OpenSetUpDlg::OnInitDialog()
{
	int nSetUps;
	CString msg;

	CDialog::OnInitDialog();
	   
	pMyDoc = GetDoc();
	ASSERT(pMyDoc);
	if(!pMyDoc)
		return TRUE;   
	   
   nSetUps = LoadAvailableSetUps((CListBox *)GetDlgItem(IDC_SETUPLIST));

   if(nSetUps == -1)
   {
		msg = "Can't open SETTINGS.DBF in ";
		msg = msg + pMyDoc->szSettingsPath;
		msg = msg + ". Make sure this path is correct and try again.";
		
		MessageBox(msg, "File Open Failed", MB_ICONEXCLAMATION);

      EndDialog(-5);
   }   
   else if(nSetUps == 0)
   {
      MessageBox("No set-ups were found!", "Settings File Empty", MB_ICONEXCLAMATION);
      EndDialog(-5);
   }
	return TRUE;  // return TRUE  unless you set the focus to a control
}


int OpenSetUpDlg::LoadAvailableSetUps(CListBox* pThisLB)
{
	CDatabase DB;         
                      
   int nId;
   int nIndex;       
   int rc; 
          
   CString szEntry;
	CString msg;
   
   ShowWaitCursor();

   pThisLB->ResetContent();
                   
	CString szConn = "ODBC;DSN=FoxPro Files;Database=";
	szConn += pMyDoc->szSettingsPath;
	szConn += "\\SETTINGS.DBF";

	rc = OpenDatabase(DB, szConn, TRUE);
	if(!rc)               
	{
		ShowArrowCursor();
		return FALSE;                      
	}
	   
	TRY
	{  
	   DSettingsRecordset sn(&DB);
   	rc = sn.Open(CRecordset::snapshot, "SELECT * FROM SETTINGS ORDER BY SETUPID DESC");
	   if (!rc)
   	{
      	DB.Close();
      	ShowArrowCursor();
      	return -1;
      }   
      
   	sn.MoveFirst();
   	while(sn.IsEOF() == FALSE)
   	{   
      	szEntry = "";
      	nId = -1;
      	nId = (int)sn.m_SETUPID;                
			
			szEntry = "#";
      
      	CString Id(ToStr(nId));	
      	szEntry = szEntry + Id + " = " + sn.m_SETUPDESC;
      
      	nIndex = pThisLB->AddString(szEntry);
      	if(nIndex > -1)
      		pThisLB->SetItemData(nIndex, (DWORD) nId);

      	sn.MoveNext();
   	}

   	sn.Close();
	   DB.Close();
   }
   CATCH(CDBException, e)
   {
		ShowArrowCursor();
		msg = "Can't load Set-Up's from SETTINGS.DBF in ";
		msg += pMyDoc->szSettingsPath;
		msg += "(Error =";
		msg += e->m_strError;
		msg += ")";
   	MessageBox(msg, "Database Error", MB_ICONEXCLAMATION);
#ifdef _DEBUG                       
   	MessageBox(e->m_strStateNativeOrigin, "DB ODBC Error");
#endif		
   	return -1;
   }	   
	END_CATCH
   
   ShowArrowCursor();
   return pThisLB->GetCount();
}                  

void OpenSetUpDlg::OnOK()
{
	// TODO: Add extra validation here
	int nIndex;
	
	nIndex = (int)SendDlgItemMessage(IDC_SETUPLIST, LB_GETCURSEL, 0, 0L);
	if (nIndex == -1) 
	{
      MessageBox("Select a set-up to load first!", "No Set-Up Selected", MB_ICONEXCLAMATION);
	}  
   else
	{                        
		DBDiplomatDoc *pDoc = GetDoc();
		ASSERT(pDoc);
		if(!pDoc)
			return;
      pMyDoc->nGlobalSetUpId = (int)SendDlgItemMessage(IDC_SETUPLIST, LB_GETITEMDATA, nIndex, 0L);
      EndDialog(TRUE);
   }   
   return;
}
