// savsetup.cpp : implementation file
//

#include "stdafx.h"
#include "dbdiplom.h"
#include "dbdipdoc.h"
#include "tools.h"
#include "savsetup.h"      
#include "setngrec.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SaveSetUpDlg dialog


SaveSetUpDlg::SaveSetUpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SaveSetUpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(SaveSetUpDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void SaveSetUpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SaveSetUpDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(SaveSetUpDlg, CDialog)
	//{{AFX_MSG_MAP(SaveSetUpDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int SaveSetUpDlg::GetNewSetUpId (CString& SettingsPath)
{
   // Returns unique set-up I.D.
   CDatabase DB;
   
   int nLastId;
   int nNewId;
	int rc;        
            
	CString szConn = "ODBC;DSN=FoxPro Files;Database=";
	szConn += SettingsPath;
	szConn += "\\SETTINGS.DBF";
   
   rc = OpenDatabase(DB, szConn);
  	if(!rc)
   	return -1;
   
	TRY
	{  
	   DSettingsRecordset sn(&DB);
      rc = sn.Open(CRecordset::snapshot, "SELECT * FROM SETTINGS ORDER BY SETUPID");
 		if (!rc)
   	{
      	DB.Close();
      	return -1;
      }   
            
      sn.MoveLast();
      nLastId = -1;
      nLastId = (int)sn.m_SETUPID;
      nNewId = nLastId + 1;
      sn.Close();
      DB.Close();
      return nNewId;
   }      
	CATCH(CDBException, e)
   {
   	MessageBox(e->m_strError, "Can't Access Table SETTINGS.DBF", MB_ICONEXCLAMATION);
#ifdef _DEBUG   
   	MessageBox(e->m_strStateNativeOrigin, "DB ODBC Error");
#endif		
		if(DB.IsOpen())
			DB.Close();	
   	return -1;
   }	   
	END_CATCH
	return -1; // Kill error
}


/////////////////////////////////////////////////////////////////////////////
// SaveSetUpDlg message handlers

BOOL SaveSetUpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
           
	pMyDoc = GetDoc();      
	ASSERT(pMyDoc);
	if(!pMyDoc)
		return TRUE;     
           
   int nId;
   
   nId = GetNewSetUpId(pMyDoc->szSettingsPath);

   if (nId == -1)
      EndDialog(-5);
   else
		SetDlgItemText(IDC_SETUPID, ToStr(nId));   

   SetDlgItemText(IDC_SETUPDESC, pMyDoc->MySettings.SETUPDESC);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void SaveSetUpDlg::OnOK()
{  
	char szTemp[256];         
	
	BOOL bDummy;
	pMyDoc->MySettings.SETUPID = GetDlgItemInt(IDC_SETUPID, &bDummy, FALSE);

	GetDlgItemText(IDC_SETUPDESC, szTemp, 256);
   pMyDoc->MySettings.SETUPDESC = szTemp;
   EndDialog(TRUE);
}
