// srcsql.cpp : implementation file
//

#include "stdafx.h"
#include "dbdiplom.h"
#include "dbdipdoc.h"
#include "tools.h"
#include "srcsql.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditSrcSQLDlg dialog


EditSrcSQLDlg::EditSrcSQLDlg(CWnd* pParent /*=NULL*/)
	: CDialog(EditSrcSQLDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditSrcSQLDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void EditSrcSQLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditSrcSQLDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(EditSrcSQLDlg, CDialog)
	//{{AFX_MSG_MAP(EditSrcSQLDlg)
	ON_BN_CLICKED(IDC_USECUSTOMSQL, OnToggleCustomSQLOption)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// EditSrcSQLDlg message handlers

BOOL EditSrcSQLDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	pMyDoc = GetDoc();
	ASSERT(pMyDoc);
	if(!pMyDoc)
		return TRUE;
    	
   SetDlgItemText(IDC_CUSTOMSQL, pMyDoc->MySettings.SRC_SQL);
   if (pMyDoc->MySettings.SRC_SQL.GetLength() > 0)
      CheckDlgButton(IDC_USECUSTOMSQL, 1);
   else
      CheckDlgButton(IDC_USECUSTOMSQL, 0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void EditSrcSQLDlg::OnOK()
{
	int rc = IsDlgButtonChecked(IDC_USECUSTOMSQL);
	char szTemp[256];
	
	GetDlgItemText(IDC_CUSTOMSQL, szTemp, 256);              
	              
	if (rc == 1 && lstrlen(szTemp) > 0)
	{
      pMyDoc->MySettings.SRC_SQL = szTemp;
   }
   else                               
   	// If dialog box not checked--or-- custom SQL query not provided, clear 'global' document setting.
   	 pMyDoc->MySettings.SRC_SQL = "";
   EndDialog(TRUE);
}

void EditSrcSQLDlg::OnToggleCustomSQLOption()
{
	// Yoke enabled/disabled state of actual SQL text to option checkbox.

	int rc = IsDlgButtonChecked(IDC_USECUSTOMSQL);
                
	BOOL bEnabled = rc ? TRUE : FALSE;       
	
	GetDlgItem(IDC_CUSTOMSQL)->EnableWindow(bEnabled);         
}
