// TOOLS.CPP -- Helper functions that can be used anywhere.
#include "stdafx.h"
#include <windows.h>
#include <stdlib.h>         
#include "dbdipdoc.h"
#include "tools.h"                   
   
DBDiplomatDoc *pActiveDoc = NULL;  // Allows access to current document from anywhere.  
												// (Document encapsulates 'globals' in VB version.)
                                    
LPSTR ToStr(int n)
{
	static char szTemp[256];
	_ltoa(n, szTemp, 10);
	return (LPSTR)szTemp;
}


DBDiplomatDoc *GetDoc(void)
{
	return pActiveDoc;
}

void SetDoc(DBDiplomatDoc *pDoc)
{
   pActiveDoc = pDoc;
}

BOOL IsNumberType (int nType)
{                                                                            
	//#define SQL_NUMERIC 			2
	//#define SQL_DECIMAL 			3
	//#define SQL_INTEGER 			4
	//#define SQL_SMALLINT			5
	//#define SQL_FLOAT				6
	//#define SQL_REAL				7
	//#define SQL_DOUBLE				8
 	
	if (nType == SQL_INTEGER || nType == SQL_SMALLINT || nType == SQL_TINYINT 
		 || nType == SQL_FLOAT || nType == SQL_REAL || nType == SQL_DOUBLE)
		return TRUE;
	else
		return FALSE;   
}   
                
BOOL IsNumberTypeStr (CString& szType)
{
   if(szType == "A" || szType == "M" || szType == "D")
   	return FALSE;
   else
   	return TRUE;
}   	                   

BOOL IsTextType(int nType)
{
	if (nType == SQL_CHAR || nType == SQL_VARCHAR || nType == SQL_BINARY || nType == SQL_BINARY ||
		 nType == SQL_NUMERIC || nType == SQL_DECIMAL)  // (These two are stored as text)
   	return TRUE;
   else
   	return FALSE;
}   		
   	                                                                   
BOOL OpenDatabase(CDatabase& DB, CString& szConnect, int bReportErrors)
{                
   // Returns unique set-up I.D.
	int rc;              
	CString msg;

	TRY
	{            
		rc = DB.Open("", 0, 0, szConnect);
           
      if(rc)
      	return TRUE;
      else
      	return FALSE;	     	
   }		
   CATCH(CDBException, e)
   {                                                         
		if (bReportErrors)
		{
			msg = "Couldn't connect to database.  (Error =";
			msg += e->m_strError;
			msg += ").";
   		MessageBox(NULL, msg.GetBuffer(256), "Can't Open Database", MB_ICONEXCLAMATION);
		}
		return FALSE;								   
   }  
	AND_CATCH(CMemoryException, e)
	{
		if (bReportErrors)
   		MessageBox(NULL, "Out of Memory.", "Can't Open Database", MB_ICONEXCLAMATION);
		return FALSE;								   
	}
   END_CATCH                  
   return FALSE;  // Kill error.
}
                
                
 